import glob, platform

### ----------------------------------------------------- #
### ------------------    INCLUDES     ------------------ #
### ----------------------------------------------------- #

# Declaring common include directories
INC_DMA_CORE = '../../DmaCore/src/';
INC_DMA_EXTERNAL = '../../DmaExternal/src/';
INC_COMMON = [ INC_DMA_CORE, INC_DMA_EXTERNAL ]

# Declaring system dependent include directories 
INC_DARWIN_BOOST_DIR = '/Users/mariusz/Software/libs/boost';
INC_DARWIN_DIRS = [ INC_DARWIN_BOOST_DIR ]

INC_LINUX_BOOST_DIR = '';
INC_LINUX_DIRS = [ INC_LINUX_BOOST_DIR ]

# Adding system dependent include directories to include directory array 
INC_DIRS = INC_COMMON;
if ( platform.system() == 'Darwin' ):
    
    for INC_DIR in INC_DARWIN_DIRS: INC_DIRS.append( INC_DIR );
elif ( platform.system() == 'Linux' ):
    
    for INC_DIR in INC_LINUX_DIRS: INC_DIRS.append( INC_DIR );
else:
    print 'Platform not supported, quiting...';
    exit(0);
    
    
    
    
    
    
    
### ----------------------------------------------------- #
### ------------------    LIBRARIES    ------------------ #
### ----------------------------------------------------- #

# Declaring common libraries and directories
LIBS_COMMON= [ 'DmaExternal', 'DmaCore' ];
LIBPATH_DMA_CORE = '../../DmaCore/build';
LIBPATH_DMA_EXTERNAL = '../../DmaExternal/build';
LIBPATH_COMMON = [ LIBPATH_DMA_CORE, LIBPATH_DMA_EXTERNAL ]

# Adding system dependent include directories to include directory array
LIBS_ARR = LIBS_COMMON;
LIBPATH_ARR = LIBPATH_COMMON;







### ----------------------------------------------------- #
### ------------------    ENVIRONMENT    ---------------- #
### ----------------------------------------------------- #

# Creating and exporting environment
env = Environment( CPPPATH = INC_DIRS, LIBS = LIBS_ARR, LIBPATH = LIBPATH_ARR );
Export('env');

# Performing build
VariantDir('build', 'src', duplicate=0)
SConscript('build/SConscript')
