import glob, platform

### ----------------------------------------------------- #
### ------------------    INCLUDES     ------------------ #
### ----------------------------------------------------- #

# Declaring system dependent include directories 
INC_DARWIN_BOOST_DIR = '/Users/mariusz/Software/libs/boost';
INC_DARWIN_DIRS = [ INC_DARWIN_BOOST_DIR ];

INC_LINUX_BOOST_DIR = '';
INC_LINUX_DIRS = [ INC_LINUX_BOOST_DIR ];

# Adding system dependent include directories to include directory array 
INC_DIRS = [];
if ( platform.system() == 'Darwin' ):
    
    for INC_DIR in INC_DARWIN_DIRS: INC_DIRS.append( INC_DIR );
elif ( platform.system() == 'Linux' ):
    
    for INC_DIR in INC_LINUX_DIRS: INC_DIRS.append( INC_DIR );
else:
    print 'Platform not supported, quiting...';
    exit(0);





### ----------------------------------------------------- #
### ------------------    ENVIRONMENT    ---------------- #
### ----------------------------------------------------- #

# Creating and exporting environment
env = Environment( CPPPATH = INC_DIRS );
Export('env');

# Performing build
VariantDir('build', 'src', duplicate=0)
SConscript('build/SConscript')

