/*
 * TypeDefinitions.h
 *
 *  Created on: Dec 11, 2008
 *      Author: mariusz
 */

#ifndef TYPEDEFINITIONS_H_
#define TYPEDEFINITIONS_H_

#include <map>
#include <string>
#include <boost/shared_ptr.hpp>

namespace dma
{

	namespace core
	{

		/**
		 * Map of heterozygotic balances for markers
		 */
		typedef std::map<std::string, double> HbMap;

		/**
		 * Type representing heterozygotic balance for markers
		 */
		typedef boost::shared_ptr<std::map<std::string, double> > HbMapPtr;

	}
}

#endif /* TYPEDEFINITIONS_H_ */
