/*
 * Strategies.cpp
 *
 *  Created on: Nov 17, 2008
 *      Author: mariusz
 */

#include "Strategies.h"

namespace dma
{
	namespace core
	{

		Strategies::Strategies(Strategies::EXCLUDED_CONFIGURATIONS_STRATEGY excludedConfigurationsStrategy,
				Strategies::EQUIVALENTS_STRATEGY equivalentsStrategy,
				Strategies::IMPOSSIBLE_GENOTYPE_STRATEGY impossibleConfigurationsStrategy) :
			excludedConfigurationsStrategy_(excludedConfigurationsStrategy), equivalentsStrategy_(equivalentsStrategy),
					impossibleConfigurationsStrategy_(impossibleConfigurationsStrategy)
		{

		}

		Strategies::~Strategies()
		{

		}

		void Strategies::setEquivalentsStrategy(Strategies::EQUIVALENTS_STRATEGY equivalentsStrategy)
		{
			equivalentsStrategy_ = equivalentsStrategy;
		}

		Strategies::EQUIVALENTS_STRATEGY Strategies::getEquivalentsStrategy() const
		{
			return equivalentsStrategy_;
		}

		void Strategies::setImpossibleConfigurationStrategy(Strategies::IMPOSSIBLE_GENOTYPE_STRATEGY impossibleConfigurationsStrategy)
		{
			impossibleConfigurationsStrategy_ = impossibleConfigurationsStrategy;
		}

		Strategies::IMPOSSIBLE_GENOTYPE_STRATEGY Strategies::getImpossibleConfigurationStrategy() const
		{
			return impossibleConfigurationsStrategy_;
		}

		void Strategies::setExcludedConfigurationsStrategy(Strategies::EXCLUDED_CONFIGURATIONS_STRATEGY excludedConfigurationsStrategy)
		{
			excludedConfigurationsStrategy_ = excludedConfigurationsStrategy;
		}

		Strategies::EXCLUDED_CONFIGURATIONS_STRATEGY Strategies::getExcludedConfigurationsStrategy() const
		{
			return excludedConfigurationsStrategy_;
		}
	}
}
