/*
 * DmaException.h
 *
 *  Created on: Apr 2, 2009
 *      Author: mariusz
 */

#ifndef DMAEXCEPTION_H_
#define DMAEXCEPTION_H_

#include <stdexcept>

namespace dma
{
	namespace core
	{

		/**
		 *	Base for all exception, which may be throwned by application
		 */
		class DmaException: public std::exception
		{
		public:

			DmaException() :
				std::exception()
			{

			}

			~DmaException() throw()
			{

			}

			/**
			 * Method delivering basic information regarding exception
			 *
			 * @return
			 */
			virtual const char* what() const throw() = 0;

			/**
			 * Method delivering detailed information regarding exception
			 *
			 * @return
			 */
			virtual const char* getDescription() const throw() = 0;
		};
	}
}

#endif /* DMAEXCEPTION_H_ */
