/*
 * OverflowExcpetion.h
 *
 *  Created on: Oct 24, 2008
 *      Author: mariusz
 */

#ifndef OVERFLOWEXCPETION_H_
#define OVERFLOWEXCPETION_H_

#include "DmaException.h"
#include <boost/lexical_cast.hpp>

namespace dma
{
	namespace core
	{

		/**
		 * Exception is generated when attempt to add additional element to fixed-sized container
		 */
		class OverflowExcpetion: public DmaException
		{
		private:

			/**
			 * Size of container
			 */
			unsigned int size_;

			/**
			 * Name of container accessed
			 */
			std::string containerName_;

		public:

			OverflowExcpetion(unsigned int size, const std::string& containerName = "") throw() :
				size_(size), containerName_(containerName)
			{

			}

			~OverflowExcpetion() throw()
			{

			}

			/**
			 *
			 * @return Maximum size of container
			 */
			unsigned int getSize() const
			{

				return size_;
			}

			/**
			 *
			 * @return Name of container
			 */
			std::string getContainerName() const
			{

				return containerName_;
			}

			const char* what() const throw()
			{

				std::string s = "Exception - Container overflow";
				return s.c_str();
			}

			const char* getDescription() const throw()
			{

				std::string s = "";
				s = s + "Error has been reported while adding elements to container '" + containerName_ + "': ";
				s = s + "Couldn't add since maximum number elements ( " + boost::lexical_cast<std::string>(size_)
						+ " ) has been reached";
				return s.c_str();
			}
		};
	}
}

#endif /* OVERFLOWEXCPETION_H_ */
