#include "CharacterAllele.h"

namespace dma
{
	namespace core
	{

		CharacterAllele::CharacterAllele(char alleleValue, double peakHeight, double peakArea) :
			AlleleBase((double) (alleleValue), 0.0, peakHeight, peakArea, AlleleBase::CHARACTER)
		{
		}

		CharacterAllele::~CharacterAllele()
		{

		}

		AlleleBasePtr CharacterAllele::cloneToPtr() const
		{

			CharacterAllelePtr cap(new CharacterAllele(getAlleleValueAsChar(), peakArea_, peakHeight_));
			cap->setMarkerName(getMarkerName());
			cap->setFrequency(getFrequency());
			return cap;
		}

		std::string CharacterAllele::getAlleleValueAsString() const
		{

			std::string s1("");
			s1.append(1, getAlleleValueAsChar());
			return s1;
		}

		char CharacterAllele::getAlleleValueAsChar() const
		{

			int i = (int) alleleValue_;
			return (char) i;
		}

		std::string CharacterAllele::toString() const
		{
			std::string buffer;
			buffer = "C Allele: " + getAlleleValueAsString() + ", PH: " + lexical_cast<std::string> (peakHeight_) + ", PA: "
					+ lexical_cast<std::string> (peakArea_) + ",FREQ: " + lexical_cast<std::string> (frequency_);

			return buffer;
		}
	}
}
