#include "Hypothesis.h"

namespace dma
{
	namespace core
	{

		Hypothesis::Hypothesis(std::string name, TYPE type) :
			name_(name), type_(type), contributors_(new std::vector<PersonPtr>)
		{

		}

		Hypothesis::~Hypothesis()
		{
		}

		Hypothesis::TYPE Hypothesis::getType() const
		{
			return type_;
		}

		void Hypothesis::addContributor(PersonPtr contributor)
		{
			contributors_->push_back(contributor);
		}

		unsigned int Hypothesis::getNumberOfContributors() const
		{
			return contributors_->size();
		}

		PersonPtr Hypothesis::getContributor(unsigned int index) const
		{
			if (index < contributors_->size())
			{
				return contributors_->at(index);
			}
			else
			{
				throw OutOfBoundsException(index, contributors_->size(), "Hypothesis::getContributor()::contributors_");
			}
		}
	}
}
