#include "NumericAllele.h"

namespace dma
{
	namespace core
	{

		NumericAllele::NumericAllele(double allelValue, double alleleSize, double peakHeight, double peakArea) :
			AlleleBase(allelValue, alleleSize, peakHeight, peakArea, AlleleBase::NUMERIC)
		{
		}

		NumericAllele::~NumericAllele()
		{

		}

		AlleleBasePtr NumericAllele::cloneToPtr() const
		{

			NumericAllelePtr nap(new NumericAllele(alleleValue_, alleleSize_, peakHeight_, peakArea_));
			nap->setMarkerName(getMarkerName());
			nap->setFrequency(getFrequency());
			return nap;
		}

		std::string NumericAllele::getAlleleValueAsString() const
		{

			//return lexical_cast<std::string> (alleleValue_);
			return dma::utils::toString(alleleValue_);
		}

		std::string NumericAllele::toString() const
		{

			std::string buffer;
			buffer = "N Allele: " + getAlleleValueAsString() + ", size " + lexical_cast<std::string> (alleleSize_) + ", PH: "
					+ lexical_cast<std::string> (peakHeight_) + ", PA: " + lexical_cast<std::string> (peakArea_) + ", FREQ: "
					+ lexical_cast<std::string> (frequency_) + ", T " + lexical_cast<std::string> ( (int)type_) + ", MARKER: "
					+ lexical_cast<std::string> (markerName_);

			return buffer;
		}
	}
}
