/*
 * AlgExp.h
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#ifndef ALGEXP_H_
#define ALGEXP_H_

#include <string>
#include <boost/shared_ptr.hpp>

using namespace boost;

namespace dma
{
	namespace core
	{

		class AlgExp;

		/**
		 * Smart pointer to object of type AlgExp
		 */
		typedef shared_ptr<AlgExp> AlgExpPtr;

		/**
		 * Abstract class representing algebraic expressions, which can be as numeric value or an algebraic operation.
		 * Class defines method for getting expression as as symbol or as name
		 */
		class AlgExp
		{

		public:

			AlgExp();

			virtual ~AlgExp();

			/**
			 * Method returns algebraic expression as mathematic symbol
			 * @return
			 */
			virtual std::string getSymbol() const = 0;

			/**
			 * Method returns value of an algebraic expression
			 * @return
			 */
			virtual double getValue() const = 0;
		};
	}
}

#endif /* ALGEBRAICEXPRESSION_H_ */
