/*
 * AlgOper.cpp
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#include "AlgOper.h"

namespace dma
{

	namespace core
	{

		AlgOper::AlgOper(AlgExpPtr expression1, AlgExpPtr expression2) :
			expressions_(new std::vector<AlgExpPtr>())
		{
			expressions_->push_back(expression1);
			expressions_->push_back(expression2);
		}

		AlgOper::~AlgOper()
		{

		}

		void AlgOper::addExp(AlgExpPtr expression)
		{

			expressions_->push_back(expression);
		}

		std::string AlgOper::getSymbol() const
		{

			std::string operand = getOperand();
			std::string buffer = "( ";

			unsigned int i;
			unsigned int size = expressions_->size();
			for (i = 0; i < size; i++)
			{

				buffer = buffer + expressions_->at(i)->getSymbol();
				buffer = buffer + " ";
				if (i != (size - 1))
				{
					buffer = buffer + operand;
					buffer = buffer + " ";
				}
			}

			buffer = buffer + ")";

			return buffer;
		}

	}
}
