/*
 * AlgOper.h
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#ifndef ALGOPER_H_
#define ALGOPER_H_

#include <vector>
#include <boost/shared_ptr.hpp>
#include "AlgExp.h"

using namespace boost;

namespace dma
{

	namespace core
	{

		class AlgOper;
		typedef shared_ptr<AlgOper> AlgOperPtr;

		class AlgOper: public AlgExp
		{
		protected:

			/**
			 * Expressions used with operation
			 */
			shared_ptr<std::vector<AlgExpPtr> > expressions_;

		public:

			/**
			 * Constructor
			 *
			 * @param expression1
			 * @param expression2
			 * @return
			 */
			AlgOper(AlgExpPtr expression1, AlgExpPtr expression2);

			/**
			 * Add expression to operation
			 *
			 * @param expression
			 */
			void addExp(AlgExpPtr expression);

			/**
			 * @see AlgExp::getSymbol()
			 * @return
			 */
			std::string getSymbol() const;

			/**
			 * @see AlgExp::getValue()
			 * @return
			 */
			virtual double getValue() const = 0;

			/**
			 * Get operand
			 * @return
			 */
			virtual std::string getOperand() const = 0;

		public:
			virtual ~AlgOper();
		};

	}
}

#endif /* ALGEBRAICOPERATION_H_ */
