/*
 * AlgOperDiv.cpp
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#include "AlgOperDiv.h"

namespace dma
{

	namespace core
	{

		AlgOperDiv::AlgOperDiv(AlgExpPtr expression1, AlgExpPtr expression2) :
			AlgOper(expression1, expression2)
		{

		}

		AlgOperDiv::~AlgOperDiv()
		{

		}

		std::string AlgOperDiv::getOperand() const
		{

			std::string s = "/";
			return s;
		}

		double AlgOperDiv::getValue() const throw(DivisionByZeroException)
		{

			unsigned int i;
			unsigned int size = expressions_->size();

			double result = expressions_->at(0)->getValue();

			for (i = 1; i < size; ++i)
			{

				double value = expressions_->at(i)->getValue();
				if (value != 0.0)
				{

					result = result / value;
				}
				else
				{

					throw DivisionByZeroException("Division by zero exception generated");
				}
			}

			return result;
		}
	}
}
