/*
 * AlgOperDiv.h
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#ifndef ALGOPERDIV_H_
#define ALGOPERDIV_H_

#include "AlgValue.h"
#include "AlgOper.h"
#include "DivisionByZeroException.h"

namespace dma
{

	namespace core
	{

		class AlgOperDiv;
		typedef shared_ptr<AlgOperDiv> AlgOperDivPtr;

		class AlgOperDiv: public AlgOper
		{
		public:
			AlgOperDiv(AlgExpPtr expression1, AlgExpPtr expression2);
			virtual ~AlgOperDiv();

			/**
			 * @see AlgExp::getValue()
			 * @return
			 * @exception DivisionByZeroException
			 */
			double getValue() const throw(DivisionByZeroException);

			/**
			 * @see AlgOper::getOperand()
			 * @return
			 */
			std::string getOperand() const;
		};

	}
}

#endif /* ALGEBRAICOPERATIONDIVISION_H_ */
