/*
 * AlgValue.h
 *
 *  Created on: Dec 21, 2008
 *      Author: mariusz
 */

#ifndef ALGVALUE_H_
#define ALGVALUE_H_

#include <string>
#include "AlgExp.h"

namespace dma
{

	namespace core
	{

		class AlgValue;
		typedef shared_ptr<AlgValue> AlgValuePtr;

		class AlgValue: public AlgExp
		{
		private:

			/**
			 * Algebraic symbol representing variable
			 */
			std::string symbol_;

			/**
			 * Algebraic value
			 */
			double value_;

		public:

			/**
			 * Create new algebraic value with given symbol
			 *
			 * @param symbol
			 * @param value
			 * @return
			 */
			AlgValue(std::string symbol, double value);

			virtual ~AlgValue();

			/**
			 * @see AlgExp::getSymbol()
			 * @return
			 */
			std::string getSymbol() const;

			/**
			 * @see AlgExp::getValue()
			 * @return
			 */
			double getValue() const;
		};
	}
}

#endif /* ALGEBRAICVALUE_H_ */
