/*
 * MCStatusExcAlleleMissing.cpp
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#include "MCStatusExcAlleleMissing.h"

namespace dma
{

	namespace core
	{

		MCStatusExcAlleleMissing::MCStatusExcAlleleMissing() :
			MCStatus( MCStatusExcAlleleMissing::getStatusName(), false), alleleMissing_(new NumericAllele(0))
		{

		}

		MCStatusExcAlleleMissing::MCStatusExcAlleleMissing(AlleleBasePtr alleleMissing) :
			MCStatus( MCStatusExcAlleleMissing::getStatusName(), false), alleleMissing_(alleleMissing)
		{

		}

		MCStatusExcAlleleMissing::~MCStatusExcAlleleMissing()
		{

		}

		AlleleBasePtr MCStatusExcAlleleMissing::getAllele() const {

			return alleleMissing_;
		}

		MCStatusPtr MCStatusExcAlleleMissing::cloneToPtr() const
		{

			MCStatusPtr output(new MCStatusExcAlleleMissing(alleleMissing_->cloneToPtr()));
			return output;
		}

		std::string MCStatusExcAlleleMissing::toString() const
		{

			std::string buffer = "Configuration is excluded since allele ";
			buffer = buffer + alleleMissing_->getAlleleValueAsString();
			buffer = buffer + " from mixture sample sample is not given in configuration";
			return buffer;
		}

		std::string MCStatusExcAlleleMissing::getStatusName() {

			return "EXCLUDED_ALLELE_MISSING";
		}
	}
}
