/*
 * MCStatusExcDuplication.h
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#ifndef MCSTATUSEXCDUPLICATION_H_
#define MCSTATUSEXCDUPLICATION_H_

#include <string>
#include "MCStatus.h"

using namespace boost;

namespace dma
{

	namespace core
	{

		class MCStatusExcDuplication;

		/**
		 * Smart pointer to object of class MCStatusExcDuplicationPtr
		 */
		typedef shared_ptr<MCStatusExcDuplication> MCStatusExcDuplicationPtr;

		/**
		 * Marker configuration status indicating duplicated configuration has already been generated
		 */
		class MCStatusExcDuplication: public MCStatus
		{
		public:

			/**
			 * Constructor
			 *
			 * @param configuration Configuration for which status is setted
			 */
			MCStatusExcDuplication();

			virtual ~MCStatusExcDuplication();

			/**
			 * @see MCStatus::cloneToPtr()
			 * @return
			 */
			MCStatusPtr cloneToPtr() const;

			/**
			 * @see MCStatus::toString()
			 * @return
			 */
			std::string toString() const;

			/**
			 * Get textual name of status
			 * @return
			 */
			static std::string getStatusName();
		};

	}
}

#endif /* MCSTATUSEXCDUPLICATION_H_ */
