/*
 * MCStatusExcEquivalence.h
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#ifndef MCSTATUSEXCEQUIVALENCE_H_
#define MCSTATUSEXCEQUIVALENCE_H_

#include <string>
#include "MCStatus.h"

using namespace boost;

namespace dma
{

	namespace core
	{

		class MCStatusExcEquivalence;

		/**
		 * Smart pointer to object of class MCStatusExcEquivalence
		 */
		typedef shared_ptr<MCStatusExcEquivalence> MCStatusExcEquivalencePtr;

		/**
		 * Configuration indicating that equivalent configuration has already been generated
		 */
		class MCStatusExcEquivalence: public MCStatus
		{
		public:

			MCStatusExcEquivalence();

			virtual ~MCStatusExcEquivalence();

			/**
			 * @see MCStatus::cloneToPtr()
			 * @return
			 */
			MCStatusPtr cloneToPtr() const;

			/**
			 * @see MCStatus::toString()
			 * @return
			 */
			std::string toString() const;

			/**
			 * Get textual name of status
			 * @return
			 */
			static std::string getStatusName();
		};

	}
}

#endif /* MCSTATUSEXCEQUIVALENCE_H_ */
