/*
 * MCStatusExcHeterozygoticImbalance.cpp
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#include "MCStatusExcHeterozygoticImbalance.h"

namespace dma
{

	namespace core
	{

		MCStatusExcHeterozygoticImbalance::MCStatusExcHeterozygoticImbalance() :
			MCStatus(MCStatusExcHeterozygoticImbalance::getStatusName(), false), hb_(0)
		{

			NumericAllelePtr na0(new NumericAllele(0));
			locus_.reset(new Locus(na0->cloneToPtr(), na0->cloneToPtr()));
		}

		MCStatusExcHeterozygoticImbalance::MCStatusExcHeterozygoticImbalance(LocusPtr locus, double hb) :
			MCStatus(MCStatusExcHeterozygoticImbalance::getStatusName(), false), locus_(locus), hb_(hb)
		{

		}

		MCStatusExcHeterozygoticImbalance::~MCStatusExcHeterozygoticImbalance()
		{

		}

		MCStatusPtr MCStatusExcHeterozygoticImbalance::cloneToPtr() const
		{

			MCStatusExcHeterozygoticImbalancePtr
					output(new MCStatusExcHeterozygoticImbalance(locus_->cloneToSmartPtr(), getHb()));
			return output;
		}

		LocusPtr MCStatusExcHeterozygoticImbalance::getLocus() const
		{

			return locus_;
		}

		double MCStatusExcHeterozygoticImbalance::getHb() const
		{

			return hb_;
		}

		std::string MCStatusExcHeterozygoticImbalance::toString() const
		{

			std::string buffer = "Configuration is excluded since heterozygotic balance is not met for locus ";
			buffer = buffer + locus_->toString() + ". ";
			buffer = buffer + "Heterozygotic balance: " + lexical_cast<std::string> (hb_);

			return buffer;
		}

		std::string MCStatusExcHeterozygoticImbalance::getStatusName()
		{

			return "EXCLUDED_HETEROZYGOTIC_IMBALANCE";
		}

	}
}
