/*
 * MCStatusExcKnownProfile.cpp
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#include "MCStatusExcKnownProfile.h"

namespace dma
{

	namespace core
	{

		MCStatusExcKnownProfile::MCStatusExcKnownProfile() :
			MCStatus( MCStatusExcKnownProfile::getStatusName(), false)
		{

			NumericAllelePtr na0(new NumericAllele(0));
			missingLocus_.reset(new Locus(na0->cloneToPtr(), na0->cloneToPtr()));
		}

		MCStatusExcKnownProfile::MCStatusExcKnownProfile(LocusPtr missingLocus) :
			MCStatus( MCStatusExcKnownProfile::getStatusName(), false), missingLocus_(missingLocus)
		{

		}

		MCStatusExcKnownProfile::~MCStatusExcKnownProfile()
		{

		}

		MCStatusPtr MCStatusExcKnownProfile::cloneToPtr() const
		{

			MCStatusExcKnownProfilePtr output(new MCStatusExcKnownProfile(missingLocus_->cloneToSmartPtr()));
			return output;
		}

		LocusPtr MCStatusExcKnownProfile::getMissingLocus() const
		{

			return missingLocus_;
		}

		std::string MCStatusExcKnownProfile::toString() const
		{
			std::string buffer = "Configuration is excluded since it does not include locus from known profile. Missing locus: ";
			buffer = buffer + missingLocus_->toString();

			return buffer;
		}

		std::string MCStatusExcKnownProfile::getStatusName()
		{

			return "EXCLUDED_KNOWN_PROFILE";
		}

	}
}
