/*
 * MCStatusValid.h
 *
 *  Created on: Jan 6, 2009
 *      Author: mariusz
 */

#ifndef MCSTATUSVALID_H_
#define MCSTATUSVALID_H_

#include <string>
#include "MCStatus.h"

using namespace boost;

namespace dma
{

	namespace core
	{

		class MCStatusValid;

		typedef shared_ptr<MCStatusValid> MCStatusValidPtr;

		class MCStatusValid: public MCStatus
		{
		public:

			MCStatusValid();

			/**
			 * @see MCStatus::cloneToPtr()
			 * @return
			 */
			MCStatusPtr cloneToPtr() const;

			virtual ~MCStatusValid();

			/**
			 * @see MCStatus::toString()
			 * @return
			 */
			std::string toString() const;

			/**
			 * Retrieve textual name of status
			 * @return
			 */
			static std::string getStatusName();
		};
	}
}

#endif /* MCSTATUSVALID_H_ */
