/*
 * MixtureDataPrinters.h
 *
 *  Created on: Oct 28, 2008
 *      Author: mariusz
 */

#ifndef MIXTUREDATAPRINTERS_H_
#define MIXTUREDATAPRINTERS_H_

#include <string>
#include <boost/shared_ptr.hpp>
#include "../models/CharacterAllele.h"
#include "../models/NumericAllele.h"
#include "../models/Marker.h"
#include "../models/MarkerConfiguration.h"
#include "../models/Sample.h"

using namespace dma::core;

namespace dma
{
	namespace utils
	{

		/**
		 * Method returns std::string with information regarding allele frequency in given list of markers
		 * @return String
		 */
		std::string getTextMarkerFrequency(shared_ptr<std::vector<MarkerPtr> > data);
		std::string getTextAllele(AlleleBasePtr allel);
		std::string getTextMarker(MarkerPtr marker);
		std::string getTextSample(SamplePtr sample);
		std::string getTextSamples(shared_ptr<std::vector<SamplePtr> > data);

		void printMarkerFrequency(shared_ptr<std::vector<MarkerPtr> > data);
		void printAllel(AlleleBasePtr allele);
		void printMarker(MarkerPtr marker);
		void printSample(SamplePtr sample);
		void printSamplesData(shared_ptr<std::vector<SamplePtr> > data);

		/**
		 * Print to standard output representation of marker configuration
		 * @param configuration
		 */
		void printMarkerConfiguration(MarkerConfigurationPtr configuration);

		/**
		 * Print to standard output representation of set of marker configurations
		 * @param configurations
		 */
		void printMarkerConfigurations(MarkerConfigurationPtrVectorPtr configurations);
	}
}

#endif /* MIXTUREDATAPRINTERS_H_ */
