#ifndef FILENOTFOUNDEXCEPTION_H_
#define FILENOTFOUNDEXCEPTION_H_

#include <string>
#include "IOException.h"

namespace dma
{

	namespace external
	{

		class FileNotFoundException: public IOException
		{
		private:

			std::string filename_;
		public:
			FileNotFoundException(std::string filename, const std::string& s) :
				IOException(s), filename_(filename)
			{

			}

			virtual const char* what() const throw()
			{
				std::string errorMsg = "File '" + filename_ + "' has not been found";
				return errorMsg.c_str();
			}

			~FileNotFoundException() throw()
			{

			}

		};
	}
}

#endif /*FILENOTFOUNDEXCEPTION_H_*/
