/*
 * IOException.h
 *
 *  Created on: Oct 28, 2008
 *      Author: mariusz
 */

#ifndef IOEXCEPTION_H_
#define IOEXCEPTION_H_

#include <string>
#include <stdexcept>

namespace dma
{

	namespace external
	{

		class IOException: public std::runtime_error
		{
		public:
			IOException(const std::string& s) :
				std::runtime_error(s)
			{

			}

			~IOException() throw()
			{

			}

			virtual const char* what() const throw()
			{
				// Casting up
				std::runtime_error* parent = (runtime_error*) (this);

				std::string errorMsg = "I/O Error: ";
				errorMsg.append(parent->what());
				return errorMsg.c_str();
			}
		};
	}
}

#endif /* IOEXCEPTION_H_ */
