/*
 * DataParser.cpp
 *
 *  Created on: Nov 30, 2008
 *      Author: mariusz
 */

#include "DataParser.h"

namespace dma
{

	namespace external
	{

		DataParser::DataParser(std::string filename, std::string fileType, std::string separator) :
			reader_(new CsvFileReader(filename, separator)), fileType_(fileType)
		{

		}

		DataParser::~DataParser()
		{

		}

		std::string DataParser::convertFloatingPoints(const std::string& input) const
		{
			std::string output = input;

			size_t pos = input.find(",");
			if (pos != std::string::npos)
			{
				output = output.replace(pos, 1, ".");
			}

			return output;
		}

		std::string DataParser::trimQuotation(const std::string& input) const
		{
			std::string out = input;

			// Empty strings
			if (out.size() == 0)
			{
				return out;
			}

			// Removing starting "
			if (input.at(0) == '"')
			{
				out = input.substr(1);
			}

			// Removing trailing "
			if (out.length() > 0 && out.at(out.length() - 1) == '"')
			{
				out = out.substr(0, out.length() - 1);
			}

			return out;
		}

		std::string DataParser::getFileType() const{

			return fileType_;
		}

	}
}
