#ifndef VALIDATOR_H_
#define VALIDATOR_H_

#include <string>
#include <boost/lexical_cast.hpp>

using boost::lexical_cast;
using boost::bad_lexical_cast;

namespace dma
{

	namespace external
	{

		/**
		 * Class introduces functions for type validation for std::string variables
		 */
		class Validator
		{

		public:
			Validator()
			{
			}
			virtual ~Validator()
			{
			}

			/**
			 * Method returns information whether given std::string stores double value ( with . as decimal point )
			 *
			 * @param str
			 * @return
			 */
			static bool isDouble(std::string str)
			{

				try
				{

					lexical_cast<double> (str);
					return true;
				} catch (bad_lexical_cast& e)
				{

					return false;
				}
			}

			/**
			 * Method returns information whether given std::string stores integer value
			 *
			 * @param str
			 * @return
			 */
			static bool isInteger(std::string str)
			{

				try
				{

					lexical_cast<int> (str);
					return true;
				} catch (bad_lexical_cast& e)
				{

					return false;
				}
			}
		};
	}
}

#endif /*VALIDATOR_H_*/
