/*
 * PythonLrCalculationController.cpp
 *
 *  Created on: Jul 30, 2009
 *      Author: mariusz
 */

#include "PythonLrCalculationController.h"

namespace dma
{

	namespace python
	{

		PythonLrCalculationController::PythonLrCalculationController(std::string reportFilename,
				std::string pdFilename,
				HypothesisPython hp,
				HypothesisPython hd) : reportFilename_(reportFilename), pdFilename_(pdFilename), hp_(hp), hd_(hd), cmController_(new LrCalculationController())
		{

		}

		PythonLrCalculationController::~PythonLrCalculationController()
		{

		}

		LikelihoodRatioPython PythonLrCalculationController::calculateLr()
		{

			// Performing calculations by library
			LikelihoodRatioPtr lr = cmController_->doPerform(reportFilename_,
					pdFilename_,
					hp_.getHypothesis(),
					hd_.getHypothesis());

			// Creating output object
			LikelihoodRatioPython lrp(lr);

			return lrp;
		}
	}

}
