/*
 * PythonLrCalculationController.h
 *
 *  Created on: Jul 30, 2009
 *      Author: mariusz
 */

#ifndef PYTHONLRCALCULATIONCONTROLLER_H_
#define PYTHONLRCALCULATIONCONTROLLER_H_

#include <string>
#include "../models/HypothesisPython.h"
#include "../models/LikelihoodRatioPython.h"
#include "controllers/LrCalculationController.h"

using namespace dma::core;
using namespace dma::external;

namespace dma
{

	namespace python
	{

		/**
		 * Wrapper for calculation-unit controller
		 */
		class PythonLrCalculationController
		{
		private:

			/**
			 * Filename of output data file from step 1
			 */
			std::string reportFilename_;

			/**
			 * Population data filename
			 */
			std::string pdFilename_;

			/**
			 * Prosecutor's hypothesis
			 */
			HypothesisPython hp_;

			/**
			 * Defences's hypothesis
			 */
			HypothesisPython hd_;

			LrCalculationControllerPtr cmController_;

		public:

			PythonLrCalculationController(std::string reportFilename,
					std::string pdFilename,
					HypothesisPython hp,
					HypothesisPython hd);

			virtual ~PythonLrCalculationController();

			/**
			 * Perform likelihood ratio calculation
			 */
			LikelihoodRatioPython calculateLr();
		};

	}

}

#endif /* PYTHONLRCALCULATIONCONTROLLER_H_ */
