/*
 * HypothesisPython.h
 *
 *  Created on: Jan 24, 2009
 *      Author: mariusz
 */

#ifndef HYPOTHESISPYTHON_H_
#define HYPOTHESISPYTHON_H_

#include <string>
#include <vector>
#include "models/Hypothesis.h"
#include "PersonPython.h"
#include <boost/shared_ptr.hpp>

using namespace boost;
using namespace dma::core;

namespace dma
{

	namespace python
	{

		/**
		 * Wrapper class for Hypothesis
		 */
		class HypothesisPython
		{
		private:

			/**
			 * Hypothesis name
			 */
			std::string name_;

			/**
			 * Hypothesis type
			 */
			std::string type_;

			/**
			 * List of contributors
			 */
			shared_ptr<std::vector<PersonPython> > contributors_;
		public:

			/**
			 *
			 * @param name Hypothesis name
			 * @param type Hypothesis type - 'P'|'D'
			 * @return
			 */
			HypothesisPython(std::string name, std::string type);

			virtual ~HypothesisPython();

			/**
			 *
			 * @param contributor
			 */
			void addContributor(PersonPython contributor);

			/**
			 * Method returns un-wrapped hypothesis object
			 * @return
			 */
			HypothesisPtr getHypothesis() const;
		};

	}
}

#endif /* HYPOTHESISPYTHON_H_ */
