/*
 * LikelihoodRatioPython.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "LikelihoodRatioPython.h"

namespace dma
{

	namespace python
	{

		LikelihoodRatioPython::LikelihoodRatioPython() :
			lr_(new LikelihoodRatio())
		{

		}

		LikelihoodRatioPython::LikelihoodRatioPython(LikelihoodRatioPtr lr) :
			lr_(lr)
		{

		}

		LikelihoodRatioPython::~LikelihoodRatioPython()
		{

		}

		std::string LikelihoodRatioPython::getMarkerNames() const
		{

			// Fetching marker names
			shared_ptr<std::vector<std::string> > markerNames = lr_->getMarkerNames();
			std::vector<std::string>::const_iterator it1;

			// Building JSON string
			std::string buffer = "[ ";
			unsigned int i;
			unsigned int size = markerNames->size();
			for (i = 0; i < size; i++)
			{

				buffer = buffer + "\"" + markerNames->at(i) + "\"";
				if (i != (size - 1))
				{
					buffer = buffer + ", ";
				}
			}
			buffer = buffer + "]";

			return buffer;
		}

		double LikelihoodRatioPython::getLrValue(std::string markerName) const
		{

			double lrValue = lr_->getLikelihoodRatio(markerName)->getValue();

			return lrValue;
		}

		std::string LikelihoodRatioPython::getLrFormula(std::string markerName) const
		{

			std::string symbol = lr_->getLikelihoodRatio(markerName)->getSymbol();

			return symbol;
		}

		double LikelihoodRatioPython::getTotalLrValue() const
		{

			double lrValue = lr_->calculateTotalLr()->getValue();

			return lrValue;
		}

	}
}
