/*
 * LikelihoodRatioPython.h
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#ifndef LIKELIHOODRATIOPYTHON_H_
#define LIKELIHOODRATIOPYTHON_H_

#include "models/LikelihoodRatio.h"

using namespace boost;
using namespace dma::core;

namespace dma
{

	namespace python
	{

		class LikelihoodRatioPython
		{
		private:

			LikelihoodRatioPtr lr_;
		public:

			/**
			 * Build empty likelihood ratio
			 * @return
			 */
			LikelihoodRatioPython();

			/**
			 * Build likelihood ratio python wrapper from likelihood ratio object
			 * @param lr
			 * @return
			 */
			LikelihoodRatioPython(LikelihoodRatioPtr lr);

			virtual ~LikelihoodRatioPython();

			/**
			 * Method returns marker names given in JSON format
			 * @return
			 */
			std::string getMarkerNames() const;

			/**
			 * Get likelihood ration value for given marker
			 * @param markerName Marker name
			 * @return
			 */
			double getLrValue(std::string markerName) const;

			/**
			 * Get likelihood ration value for given marker
			 * @param markerName Marker name
			 * @return
			 */
			std::string getLrFormula(std::string markerName) const;

			/**
			 * Get likelihood ratio for all markers
			 * @return
			 */
			double getTotalLrValue() const;
		};

	}
}

#endif /* LIKELIHOODRATIOPYTHON_H_ */
