/*
 * Table.h
 *
 *  Created on: Jan 21, 2009
 *      Author: mariusz
 */

#ifndef TABLE_H_
#define TABLE_H_

#include <vector>
#include "TableRow.h"

namespace dma
{

	namespace python
	{

		class Table
		{
		private:

			/**
			 * Rows contained within the table
			 */
			std::vector<TableRow> rows_;

		public:

			Table();

			virtual ~Table();

			/**
			 * Add row to table
			 * @param row
			 */
			void addRow(TableRow row);

			/**
			 * Get number of rows in table
			 * @return
			 */
			unsigned int getRowsNumber() const;

			/**
			 * Get row with given index
			 *
			 * @param index
			 * @return
			 */
			TableRow getRow(unsigned int index);
		};
	}
}

#endif /* TABLE_H_ */
