/*
 * TableDataCell.h
 *
 *  Created on: Jan 19, 2009
 *      Author: mariusz
 */

#ifndef TABLECELL_H_
#define TABLECELL_H_

#include <boost/python.hpp>
#include <string>

using namespace boost::python;

namespace dma
{

	namespace python
	{

		/**
		 * Class representing single cell of an table. Cell can be header or normal ( data ) one
		 */
		class TableCell
		{
		public:

			static const char CELL_TYPE_HEADER = 'H';

			static const char CELL_TYPE_DATA = 'D';

		private:

			/**
			 * Cell type
			 */
			char cellType_;

			/**
			 * Cell content
			 */
			std::string contents_;

		public:

			/**
			 *
			 *
			 * @param cellType Cell type - header or data
			 * @param contents Cell contents
			 * @return
			 */
			TableCell(char cellType, std::string contents);

			virtual ~TableCell();

			/**
			 *
			 * @return
			 */
			char getCellType() const;

			/**
			 *
			 * @param cellType
			 */
			void setCellType(char cellType);

			/**
			 *
			 * @return
			 */
			std::string getContents() const;
		};
	}
}

#endif /* TABLEDATACELL_H_ */

