/*
 * TableRow.h
 *
 *  Created on: Jan 19, 2009
 *      Author: mariusz
 */

#ifndef TABLEROW_H_
#define TABLEROW_H_

#include <string>
#include <vector>
#include "TableCell.h"

namespace dma
{

	namespace python
	{

		class TableRow
		{
		private:

			/**
			 * Type of cells in row
			 */
			char cellType_;

			/**
			 * Cells in the row
			 */
			std::vector<TableCell> cells_;

		public:

			TableRow(char cellType);

			virtual ~TableRow();

			/**
			 * Add cell with given contents
			 * @param contents Cell contents
			 */
			void addCell(std::string contents);

			/**
			 * Get number of cells within the row
			 * @return
			 */
			unsigned int getCellsNumber();

			/**
			 * Get cell with given index
			 * @param index
			 * @return
			 */
			TableCell getCell(unsigned int index);
		};
	}
}

#endif /* TABLEROW_H_ */
