/*
 * wrapers.cpp
 *
 *  Created on: Jan 21, 2009
 *      Author: mariusz
 */

#include "wrapers.h"

namespace dma {

	namespace python {

	BOOST_PYTHON_MODULE(dmapython)
		{

			 enum_<ExternalDataParser::MIXTURE_DATA_FILE_FORMAT>("MixtureDataFileFormat")
		        .value("ColumnarFormat", ExternalDataParser::COLUMNAR_FORMAT)
		        .value("LinearFormat", ExternalDataParser::LINEAR_FORMAT)
		        .export_values();

			class_<TableCell> ("TableCell", init<char, std::string>() )
				.def("getCellType", &TableCell::getCellType )
				.def("getContents", &TableCell::getContents )
			;

			class_<TableRow> ("TableRow", init<char>() )
				.def("addCell", &TableRow::addCell )
				.def("getCellsNumber", &TableRow::getCellsNumber )
				.def("getCell", &TableRow::getCell )
			;

			class_<Table> ("Table", init<>() )
				.def("addRow", &Table::addRow )
				.def("getRowsNumber", &Table::getRowsNumber )
				.def("getRow", &Table::getRow )
			;

			class_<PersonPython> ("PersonPython", init<std::string, std::string>() );

			class_<HypothesisPython> ("HypothesisPython", init<std::string, std::string>() )
				.def("addContributor", &HypothesisPython::addContributor );

			class_<LikelihoodRatioPython> ("LikelihoodRatioPython", init<>() )
				.def("getMarkerNames", &LikelihoodRatioPython::getMarkerNames)
				.def("getLrValue", &LikelihoodRatioPython::getLrValue)
				.def("getLrFormula", &LikelihoodRatioPython::getLrFormula)
				.def("getTotalLrValue", &LikelihoodRatioPython::getTotalLrValue)
				;

			class_<PythonDeconvolutionController> ("PythonDeconvolutionController", init<std::string, ExternalDataParser::MIXTURE_DATA_FILE_FORMAT, std::string, std::string>() )
				.def("addMixtureProportion", &PythonDeconvolutionController::addMixtureProportion )
				.def("deconvulate", &PythonDeconvolutionController::deconvulate )
			;

			class_<PythonLrCalculationController> ("PythonLrCalculationController", init<std::string, std::string, HypothesisPython, HypothesisPython>() )
				.def("calculateLr", &PythonLrCalculationController::calculateLr )
				;

		}
	}
}


