import unittest
import dmapython

class HypothesisPythonTestCase(unittest.TestCase):

    def testHypothesisPythonCreation_Valid(self):
        
        # Creating valid hypothesis
        hpD = dmapython.HypothesisPython('Hypothesis - defence', 'D');
        hpP = dmapython.HypothesisPython('Hypothesis - prosecutor', 'P');
        p1 = dmapython.PersonPython('Person #1', '');
        hpD.addContributor( p1 );
        
    def testHypothesisPythonCreation_Invalid(self):
        
        # Creating invalid hypothesis - incorrect type
        self.assertRaises(RuntimeError, dmapython.HypothesisPython, 'Incorrect hypothesis type', 'U');
        
        # Creating invalid hypothesis - type not given
        self.assertRaises(RuntimeError, dmapython.HypothesisPython, 'Incorrect hypothesis type', '');
        
        # Creating invalid hypothesis - no-name given
        self.assertRaises(RuntimeError, dmapython.HypothesisPython, '', 'P');
        