import unittest
import dmapython
import simplejson as json

class PersonPythonTestCase(unittest.TestCase):

    def testPersonPythonCreation_Valid(self):
        
        # Creating person with empty profile
        profile1 = '';
        person1 = dmapython.PersonPython('Person #1', profile1 );
        
        # Creating person with non-empty profile
        profile2 = [ ['Marker1', '10', '11'], ['Marker2', '12', '13'] ];
        person2 = dmapython.PersonPython('Person #2', json.dumps(profile2) );
        
        
    def testPersonPythonCreation_InvalidProfile(self):
        
        # Error in level 1 - expecting array
        profile1 = 10;
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile1) );
        
        # Error in level 2 - expecting array but single object given
        profile2 = [10, 11, 12, 13];
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile2) ); 
        
        # Error in level 2 - expecting array of size 3, but 1 given
        profile3 = [[10],[11],[12],[13]];
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile3) );
        
        # Error in level 3 - expecting string object to represent marker name
        profile4 = [[13,'11','12']];
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile4) ); 
        
        # Error in level 3 - expecting string object to represent allele 1 value
        profile5 = [['13',11,'12']];
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile5) );
        
        # Error in level 3 - expecting string object to represent allele 2 value
        profile6 = [['13','11',12]];
        self.assertRaises(RuntimeError, dmapython.PersonPython, 'Person', json.dumps(profile6) );     
        
        