import unittest
import dmapython

class TableRowTest(unittest.TestCase):

    def testTableRowCreation(self):
        
        # Creating empty row
        tr1 = dmapython.TableRow('D');
        self.assertEqual( 0, tr1.getCellsNumber() );
        
        # Adding additional cells
        tr1.addCell('Cell #1');
        tr1.addCell('Cell #2');
        
        # Testing access to existing cells
        self.assertEqual( 2, tr1.getCellsNumber() );
        self.assertEqual( 'D', tr1.getCell(0).getCellType() );
        self.assertEqual( 'D', tr1.getCell(1).getCellType() );
        self.assertEqual( 'Cell #1', tr1.getCell(0).getContents() );
        self.assertEqual( 'Cell #2', tr1.getCell(1).getContents() );
        
        # Testing access to not existing cells - Cell of type 'D' with content 'CELL_NOT_AVAILABLE' should be returned
        self.assertEqual( 'D', tr1.getCell(2).getCellType() );
        self.assertEqual( 'CELL_NOT_AVAILABLE', tr1.getCell(2).getContents() ); 
        
        