import unittest
import dmapython

class TableTestCase(unittest.TestCase):

    def testTableCreation(self):
        
        # Creating empty table
        tab1 = dmapython.Table();
        
        # Testing row counting for empty table
        self.assertEqual( 0, tab1.getRowsNumber() );
        
        # Adding some content to table
        tr1 = dmapython.TableRow('H');
        tr1.addCell('Header cell #1');
        tr1.addCell('Header cell #2');
        tr2 = dmapython.TableRow('D');
        tr2.addCell('Data cell #1');
        tr2.addCell('Data cell #2');
        tab1.addRow( tr1 );
        tab1.addRow( tr2 );
        
        # Testing row counting for non-empty table
        self.assertEqual( 2, tab1.getRowsNumber() );
        
        # Testing access to existing rows
        self.assertEqual( 2, tab1.getRow(0).getCellsNumber() );
        self.assertEqual( 2, tab1.getRow(1).getCellsNumber() );
        
        # Testing access to non-existing rows. Empty should be returned
        self.assertEqual( 0, tab1.getRow(2).getCellsNumber() );