/*
 * TestSuiteAnalysis.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "TestSuiteAnalysis.h"

namespace dma
{

	namespace test
	{

		TestSuiteAnalysis::TestSuiteAnalysis()
		{

			suite_.push_back(CUTE_SMEMFUN( TestPersonNumberAnalyzer, testGetMinimumForSample ));
			suite_.push_back(CUTE_SMEMFUN( TestPersonNumberAnalyzer, testGetMinimumForMarker ));
			suite_.push_back(CUTE_SMEMFUN( TestPersonNumberAnalyzer, testGetHBmin ));

			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testGeneratePairwiseCombinations));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testCheckForConfigurationDuplicates));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testCheckForConfigurationEquivalents));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testFilterEquivalentConfigurations));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testFilterConfigurationsByAllelePresence));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testGenerateConfigurations_2A_1P));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testGenerateConfigurations_3A_2P));
			suite_.push_back(CUTE_SMEMFUN( TestConfigurationGenerator, testConfigurationNumber));


			suite_.push_back(CUTE_SMEMFUN( TestPeakRestrictionFilter, testFilterByHb));
			suite_.push_back(CUTE_SMEMFUN( TestPeakRestrictionFilter, testFilterByMp));

			suite_.push_back(CUTE_SMEMFUN( TestProfilesFilter, testFilterSampleByKnownProfile));

			suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testFindAlleleInPopulationData));
			suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testBuildAEForLocus));
			suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testBuildAEForMarkerConfiguration));
			suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testBuildAEForMarkerConfigurations));
			suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testCalculateLr));

			//		suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testMarkerConfigurationsCloning));
			//		suite_.push_back(CUTE_SMEMFUN( TestLrCalculator, testBaldingP89));
			//
			//
			//		suite_.push_back(CUTE_SMEMFUN( TestMixAnalyzer, testMinimumPersonsNumberCalculation));
			//		suite_.push_back(CUTE_SMEMFUN( TestMixAnalyzer, testConfigurationGeneration));
			//		suite_.push_back(CUTE_SMEMFUN( TestMixAnalyzer, testMixAnalyzer));
			//		suite_.push_back(CUTE_SMEMFUN( TestMixAnalyzer, testSampleConfigurationCloning));
			//
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_3A_HE_1_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_3A_HO_1_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_4A_HE_1_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_3P_3A_HE_1_1_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_3P_3A_HO_1_1_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_3A_HE_2_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_3A_HO_2_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_2P_4A_HE_2_1 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_3P_3A_HE_1_3_2 ));
			suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_3P_3A_HO_1_3_2 ));
			//
			//		suite_.push_back(CUTE_SMEMFUN( TestPeakAllotter, test_MixSample_118_353_1a_vWA_14_18_15_17));
			//
			suite_.push_back(CUTE_SMEMFUN( TestPopulationDataAnalyzer, testVerifyPopulationData ));

		}

		TestSuiteAnalysis::~TestSuiteAnalysis()
		{

		}

		void TestSuiteAnalysis::runTests()
		{
			cute::ide_listener lis;
			cute::makeRunner(lis)(suite_, "Test suite - Analysis");

		}
	}
}
