/*
 * TestMixAnalyzer.h
 *
 *  Created on: Nov 11, 2008
 *      Author: mariusz
 */

#ifndef TESTMIXANALYZER_H_
#define TESTMIXANALYZER_H_

#include <string>
#include <map>
#include <vector>
#include <iostream>
#include "cute.h"
#include <boost/shared_ptr.hpp>
#include "models/Marker.h"
#include "models/Profile.h"
#include "models/Person.h"
#include "analysis/LrCalculator.h"
#include "analysis/MixAnalyzer.h"
#include "analysis/ConfigurationGenerator.h"
#include "parsers/HbDataParser.h"
#include "parsers/MixtureDataParserColumnarFormat.h"
#include "parsers/PopulationDataParser.h"
#include "parsers/ProfileDataParser.h"
#include "generators/DeconvolutionReportGenerator.h"
#include "TypeDefinitions.h"

using namespace dma::core;
using namespace dma::external;

namespace dma
{

	namespace test
	{

		class TestMixAnalyzer
		{
		private:

			double maxMixProportionDeviation_;
			unsigned int maxPersonsNumber_;

			MixProportionPtrMapPtr mixProportions_;

			shared_ptr<std::vector<MarkerPtr> > populationData_;
			shared_ptr<std::map<std::string, double> > hbMinData_;
			shared_ptr<std::vector<SamplePtr> > mixtureData_;
			ProfilePtrMapPtr knownProfiles_;

			MixAnalyzer* ma_;

			DeconvolutionReportGenerator* generator_;

		public:
			TestMixAnalyzer();
			virtual ~TestMixAnalyzer();

			void testSampleConfigurationCloning();
			void testMixAnalyzer();
			void testMinimumPersonsNumberCalculation();
			void testConfigurationGeneration();

		};

	}
}
#endif /* TESTMIXANALYZER_H_ */
