/*
 * TestPeakAllotter.h
 *
 *  Created on: Nov 13, 2008
 *      Author: mariusz
 */

#ifndef TESTPEAKALLOTTER_H_
#define TESTPEAKALLOTTER_H_

#include "cute.h"
#include "analysis/PeakAllotter.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class PeakAllotter
		 */
		class TestPeakAllotter: PeakAllotter
		{
		private:

			// Numerical alleles which will be used during configuraitons generation
			NumericAllelePtr na_c_1;
			NumericAllelePtr na_c_2;
			NumericAllelePtr na_c_3;
			NumericAllelePtr na_c_4;
			NumericAllelePtr na_c_5;
			NumericAllelePtr na_c_6;
		public:
			TestPeakAllotter();
			virtual ~TestPeakAllotter();

			void test_2P_3A_HE_1_1();
			void test_2P_3A_HO_1_1();
			void test_2P_4A_HE_1_1();
			void test_3P_3A_HE_1_1_1();
			void test_3P_3A_HO_1_1_1();
			void test_2P_3A_HE_2_1();
			void test_2P_3A_HO_2_1();
			void test_2P_4A_HE_2_1();
			void test_3P_3A_HE_1_3_2();
			void test_3P_3A_HO_1_3_2();
			//void test_MixSample_118_353_1a_vWA_14_18_15_17();

		};
	}
}

#endif /* TESTPEAKALLOTTER_H_ */
