/*
 * TestPersonNumberAnalyzer.h
 *
 *  Created on: Jul 19, 2009
 *      Author: mariusz
 */

#ifndef TESTPERSONNUMBERANALYZER_H_
#define TESTPERSONNUMBERANALYZER_H_

#include "cute.h"
#include "analysis/PersonNumberAnalyzer.h"
#include "models/NumericAllele.h"
#include <utility>

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class LikelihoodRatio
		 *
		 * Public method of tested class the test methods associated:
		 * 	- getMinimumForSample()
		 * 		- testGetMinimumForSample()
		 * 	- getMinimumForMarker()
		 * 		- testGetMinimumForMarker()
		 * 	- getHBmin()
		 * 		- testGetHBmin()
		 */
		class TestPersonNumberAnalyzer : public PersonNumberAnalyzer
		{
		public:
			TestPersonNumberAnalyzer();
			virtual ~TestPersonNumberAnalyzer();

			void testGetMinimumForSample();
			void testGetMinimumForMarker();
			void testGetHBmin();
		};

	}

}

#endif /* TESTPERSONNUMBERANALYZER_H_ */
