/*
 * TestPopulationDataAnalyzer.h
 *
 *  Created on: Feb 1, 2009
 *      Author: mariusz
 */

#ifndef TESTPOPULATIONDATAANALYZER_H_
#define TESTPOPULATIONDATAANALYZER_H_

#include "cute.h"

#include "analysis/PopulationDataAnalyzer.h"
#include "models/Marker.h"
#include "models/SampleConfiguration.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class PopulationDataAnalyzer
		 *
		 * Public method of tested class the test methods associated:
		 *	- verifyPopulationData
		 *		- testVerifyPopulationData
		 */
		class TestPopulationDataAnalyzer
		{
		public:
			TestPopulationDataAnalyzer();
			virtual ~TestPopulationDataAnalyzer();

			void testVerifyPopulationData();

		private:

			/**
			 * Method generates following population data:
			 *
			 * MARKER_A: 10, 11, 12, 13
			 * MARKER_B: 20, 21, 22
			 * @return
			 */
			MarkerPtrVectorPtr generatePopulationData();

			/**
			 * Method generates following sample configurations:
			 *
			 * 	- MarkerA
			 * 		- Configuration #1: (10, 11)
			 * 		- Configuration #2: (12, 13)
			 * 		- Configuration #3: (14, 15)
			 * 	- MarkerB
			 * 		- Configuration #1: (20, 23) (21, 22 )
			 * 	- MarkerC
			 * 		- Configuration #1: (40, 41)
			 * @return
			 */
			SampleConfigurationPtr generateSampleConfiguration();
		};

	}
}

#endif /* TESTPOPULATIONDATAANALYZER_H_ */

