/*
 * TestProfilesFilter.h
 *
 *  Created on: Jul 21, 2009
 *      Author: mariusz
 */

#ifndef TESTPROFILESFILTER_H_
#define TESTPROFILESFILTER_H_

#include "cute.h"
#include "analysis/ProfilesFilter.h"
#include "models/NumericAllele.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class ProfilesFilter
		 *
		 * Tested class methods coverage:
		 * 	- filterSampleByKnownProfile()
		 * 		- testFilterSampleByKnownProfile
		 *  - filterMarkerConfigurationsByKnownProfile()
		 *  	- testFilterSampleByKnownProfile
		 */
		class TestProfilesFilter
		{
		private:
			NumericAllelePtr na10;
			NumericAllelePtr na11;
			NumericAllelePtr na12;
			NumericAllelePtr na13;
			NumericAllelePtr na14;
			NumericAllelePtr na15;
		public:
			TestProfilesFilter();
			virtual ~TestProfilesFilter();

			void testFilterSampleByKnownProfile();
		};

	}

}

#endif /* TESTPROFILESFILTER_H_ */
