/*
 * TestCsvFileReader.h
 *
 *  Created on: Nov 30, 2008
 *      Author: mariusz
 */

#ifndef TESTCSVFILEREADER_H_
#define TESTCSVFILEREADER_H_

#include "io/CsvFileReader.h"
#include "boost/shared_ptr.hpp"
#include "cute.h"
#include <vector>

using namespace dma::external;
using namespace boost;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class CsvFileReader
		 *
		 * Method of tested class the test methods associated:
		 *
		 *	- CsvFileReader()
		 *		- testSeparatorDetermination
		 *	- virtual ~CsvFileReader()
		 *	- setSeparator(std::string separator)
		 *		- testSeparatorDetermination
		 *	- getSeparator()
		 *		- OMITTED: Accessor
		 *	- getLineAndExplode()
		 *		- testGetLineAndExplode()
		 */
		class TestCsvFileReader
		{
		private:

			std::string csvFileCommaSeparated;
			std::string csvFileTabSeparated;
			std::string csvFileSemicolonSeparated;

		public:
			TestCsvFileReader();
			virtual ~TestCsvFileReader();

			void testSeparatorDetermination();
			void testGetLineAndExplode();
		};

	}
}

#endif /* TESTCSVFILEREADER_H_ */

