/*
 * TestFileReader.h
 *
 *  Created on: Nov 30, 2008
 *      Author: mariusz
 */

#ifndef TESTFILEREADER_H_
#define TESTFILEREADER_H_

#include <string>
#include <iostream>
#include "cute.h"
#include "io/FileReader.h"

using namespace dma::external;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class FileReader
		 *
		 * Method of tested class the test methods associated:
		 *
		 *	- bool checkFileExists(const std::string& filename)
		 *		- testCheckFileExists()
		 *	- std::string getFilename()
		 *		- testGetFilename()
		 *	- std::string* getLine()
		 *		- testGetLine()
		 *	- char determineNewLineDelimiter()
		 *		- testDetermineNewLineDelimiter()
		 *	- void resetInputStream()
		 *		- testResetInputStream
		 */

		class TestFileReader
		{
		private:

			std::string emptyFile_;
			std::string nonExistingFile_;
			std::string nonEmptyFileWin;
			std::string nonEmptyFileMac;
			std::string nonEmptyFileUnix;
		public:
			TestFileReader();
			virtual ~TestFileReader();

			void testCheckFileExists();
			void testGetFilename();
			void testDetermineNewLineDelimiter();
		};

	}
}

#endif /* TESTFILEREADER_H_ */
