//============================================================================
// Name        : DnaMixAnalysisTests.cpp
// Author      : Mariusz Godlewski
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include "general/TestSuiteGeneral.h"
#include "analysis/TestSuiteAnalysis.h"
#include "generators/TestSuiteGenerators.h"
#include "io/TestSuiteIo.h"
#include "models/TestSuiteModels.h"
#include "parsers/TestSuiteParsers.h"
#include "python/TestSuitePython.h"
#include <stdexcept>

using namespace dma::test;

int main() {

	try {

		TestSuiteGeneral tsGeneral;
		tsGeneral.runTests();

		TestSuiteAnalysis tsAnalysis;
		tsAnalysis.runTests();

		TestSuiteGenerators tsGenerators;
		tsGenerators.runTests();

		TestSuiteIo tsIo;
		tsIo.runTests();

		TestSuiteModels tsModels;
		tsModels.runTests();

		TestSuiteParsers tsParsers;
		tsParsers.runTests();

		TestSuitePython tsPython;
		tsPython.runTests();

		return 0;
	} catch ( std::exception e ) {

		std::cerr << e.what() << std::endl;
		return 1;

		// asd5
	}
}



