/*
 * TestSuiteModels.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "TestSuiteModels.h"

namespace dma
{

	namespace test
	{

		TestSuiteModels::TestSuiteModels()
		{

			suite_.push_back(CUTE_SMEMFUN( TestAllele, testAlleleSymbolGeneration));

			suite_.push_back(CUTE_SMEMFUN( TestLocus, testAlleleAddition));
			suite_.push_back(CUTE_SMEMFUN( TestLocus, testHashGeneration));
			suite_.push_back(CUTE_SMEMFUN( TestLocus, testHbCalculation));
			suite_.push_back(CUTE_SMEMFUN( TestLocus, testPeakAreaHeightCalculation));
			suite_.push_back(CUTE_SMEMFUN( TestLocus, testCloning));

			suite_.push_back(CUTE_SMEMFUN( TestMarker, testCreationAndAddition));
			suite_.push_back(CUTE_SMEMFUN( TestMarker, testHbCalculation));
			suite_.push_back(CUTE_SMEMFUN( TestMarker, testCopyingAndAssignment));

			suite_.push_back(CUTE_SMEMFUN( TestProfile, testProfileCreation));
			suite_.push_back(CUTE_SMEMFUN( TestProfile, testAssignment));

			suite_.push_back(CUTE_SMEMFUN( TestSample, testEmptySample));
			suite_.push_back(CUTE_SMEMFUN( TestSample, testNonEmptySample));
			suite_.push_back(CUTE_SMEMFUN( TestSample, testAssignment));

			suite_.push_back(CUTE_SMEMFUN( TestSampleConfiguration, testAll ));
			suite_.push_back(CUTE_SMEMFUN( TestSampleConfiguration, testAssignment ));

			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testCopyAndAssigment));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testCloneMarkerConfigurations));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testEquivalence));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testUniqueAlleles));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testLocusSearching));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testLocusSubtraction));
			suite_.push_back(CUTE_SMEMFUN( TestMarkerConfiguration, testStatusAssignment));

			suite_.push_back(CUTE_SMEMFUN( TestMixtureProportion, testSingleContributorShareCalculation));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureProportion, testMultipleContributorShareCalculation));

			suite_.push_back(CUTE_SMEMFUN( TestPerson, testCreationWithProfile));
			suite_.push_back(CUTE_SMEMFUN( TestPerson, testCreationWithOutProfile));

			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcAlleleMissing, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcDuplication, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcEquivalence, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcHeterozygoticImbalance, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcKnownProfile, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusExcMixtureProportion, testConstructorsAndCloning));
			suite_.push_back(CUTE_SMEMFUN( TestMCStatusValid, testConstructorsAndCloning));

			suite_.push_back(CUTE_SMEMFUN( TestLikelihoodRatio, testMarkerLrAddition));
			suite_.push_back(CUTE_SMEMFUN( TestLikelihoodRatio, testTotalLrCalculation));

			suite_.push_back(CUTE_SMEMFUN( TestAlgebra, testAlgAdd));
			suite_.push_back(CUTE_SMEMFUN( TestAlgebra, testAlgSub));
			suite_.push_back(CUTE_SMEMFUN( TestAlgebra, testAlgMulti));
			suite_.push_back(CUTE_SMEMFUN( TestAlgebra, testAlgDiv));
			suite_.push_back(CUTE_SMEMFUN( TestAlgebra, testAlgComplex));
		}

		TestSuiteModels::~TestSuiteModels()
		{

		}

		void TestSuiteModels::runTests()
		{
			cute::ide_listener lis;
			cute::makeRunner(lis)(suite_, "Test suite - Models");
		}
	}
}
