/*
 * TestSuiteModels.h
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#ifndef TESTSUITEMODELS_H_
#define TESTSUITEMODELS_H_

// CUTE library includes
#include "cute.h"
#include "ide_listener.h"
#include "cute_runner.h"

// Tests includes
#include "tests/TestLikelihoodRatio.h"
#include "tests/TestAllele.h"
#include "tests/TestLocus.h"
#include "tests/TestMarker.h"
#include "tests/TestProfile.h"
#include "tests/TestSample.h"
#include "tests/TestSampleConfiguration.h"
#include "tests/TestMarkerConfiguration.h"
#include "tests/TestMixtureProportion.h"
#include "tests/TestPerson.h"
#include "tests/algebra/TestAlgebra.h"
#include "tests/statuses/TestMCStatus.h"
#include "tests/statuses/TestMCStatusExcAlleleMissing.h"
#include "tests/statuses/TestMCStatusExcDuplication.h"
#include "tests/statuses/TestMCStatusExcEquivalence.h"
#include "tests/statuses/TestMCStatusExcHeterozygoticImbalance.h"
#include "tests/statuses/TestMCStatusExcKnownProfile.h"
#include "tests/statuses/TestMCStatusExcMixtureProportion.h"
#include "tests/statuses/TestMCStatusValid.h"

namespace dma
{

	namespace test
	{

		class TestSuiteModels
		{
		private:

			/**
			 * CUTE test suite
			 */
			cute::suite suite_;

		public:
			TestSuiteModels();
			virtual ~TestSuiteModels();
			void runTests();
		};
	}
}

#endif /* TESTSUITEMODELS_H_ */
