/*
 * TestAllele.cpp
 *
 *  Created on: Oct 21, 2008
 *      Author: mariusz
 */

#include "TestAllele.h"

namespace dma
{

	namespace test
	{

		TestAllele::TestAllele()
		{

		}

		TestAllele::~TestAllele()
		{

		}

		void TestAllele::testAlleleSymbolGeneration()
		{

			NumericAllelePtr nap10(new NumericAllele(10.0));
			nap10->setFrequency(0.2);

			CharacterAllelePtr capX(new CharacterAllele('X'));
			capX->setFrequency(0.5);

			AlgValuePtr expected1(new AlgValue("p_10", 0.2));
			AlgValuePtr expected2(new AlgValue("p_X", 0.5));

			ASSERT_EQUAL( expected1->getSymbol(), nap10->getFrequencyAsAlgValue()->getSymbol() );
			ASSERT_EQUAL( expected1->getValue(), nap10->getFrequencyAsAlgValue()->getValue() );
			ASSERT_EQUAL( expected2->getSymbol(), capX->getFrequencyAsAlgValue()->getSymbol() );
			ASSERT_EQUAL( expected2->getValue(), capX->getFrequencyAsAlgValue()->getValue() );
		}

	}
}
