#ifndef TESTLOCUSGENOTYPE_H_
#define TESTLOCUSGENOTYPE_H_

#include "cute.h"
#include "models/NumericAllele.h"
#include "models/CharacterAllele.h"
#include "models/Locus.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class Locus
		 *
		 * Public method of tested class the test methods associated:
		 *
		 * 	- addAllele
		 * 		- testAlleleAddition
		 * 	- calculateHb
		 * 		- testHbCalculation
		 * 	- getAllele
		 * 		- testAlleleAddition
		 * 	- getAlleleNumber
		 * 		- testAlleleAddition
		 * 	- getHash
		 * 		- testHashGeneration
		 * 	- getMarkerName
		 * 		- testCloning
		 * 	- getTotalAlleleArea
		 * 		- testPeakAreaHeightCalculation
		 * 	- getTotalAlleleHeight
		 * 		- testPeakAreaHeightCalculation
		 * 	- getType
		 * 		- testAlleleAddition
		 * 	- getZygosity
		 * 		- testAlleleAddition
		 * 	- getZygosityAsNumber
		 * 		- testAlleleAddition
		 * 	- isAllelePresent
		 * 		- testAlleleAddition
		 * 	- setMarkerName
		 * 		- testCloning
		 * 	- toString
		 * 		- NOT TESTED - Debug purpose only
		 *  - cloneToPtr
		 *  	- testCloning
		 *  - cloneToSmartPtr
		 *  	- testCloning
		 */
		class TestLocus
		{
		public:
			TestLocus();

			void testAlleleAddition();

			void testHashGeneration();

			void testHbCalculation();

			void testPeakAreaHeightCalculation();

			void testCloning();

			virtual ~TestLocus();
		};
	}
}

#endif /*TESTLOCUSGENOTYPE_H_*/
