/*
 * TestMarker.h
 *
 *  Created on: Jul 9, 2009
 *      Author: mariusz
 */

#ifndef TESTMARKER_H_
#define TESTMARKER_H_

#include "cute.h"
#include "models/Marker.h"
#include "models/NumericAllele.h"
#include "models/CharacterAllele.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class Marker
		 *
		 * Public method of tested class the test methods associated:
		 *
		 *	- Marker(std::string name);
		 *		- testCreationAndAddition
		 *	- Marker(const Marker& copy);
		 *	- Marker& operator=(const Marker& rhs);
		 *	- virtual ~Marker();
		 *
		 *	- void addAllele(AlleleBasePtr allele);
		 *		- testCreationAndAddition
		 *	- unsigned int getAllelesNumber() const;
		 *	 	- testCreationAndAddition
		 *	- AlleleBasePtr getAllele(unsigned int index) const;
		 *	 	- testCreationAndAddition
		 *	- AlleleBasePtr getAlleleByValue(double alleleValue) const;
		 *	 	- testCreationAndAddition
		 *	- bool isAllelePresent(double alleleValue) const;
		 *		- testCreationAndAddition
		 *	- std::string getName() const;
		 *		- testCreationAndAddition
		 *	- AlleleBase::ALLELE_TYPE getType() const;
		 *		- testCreationAndAddition
		 *
		 *	- double calculateHb(unsigned index1, unsigned index2, AlleleBase::PEAK_PROPERTY peakProperty);
		 *		- testHbCalculation
		 *
		 *	- std::string toString() const;
		 */
		class TestMarker
		{
		private:

			NumericAllelePtr na10;
			NumericAllelePtr na11;
			NumericAllelePtr na20;
			NumericAllelePtr na21;

		public:

			TestMarker();
			virtual ~TestMarker();

			void testCreationAndAddition();
			void testHbCalculation();
			void testCopyingAndAssignment();
		};

	}

}

#endif /* TESTMARKER_H_ */
