/*
 * TestMarkerConfiguration.h
 *
 *  Created on: Oct 16, 2008
 *      Author: mariusz
 */

#ifndef TESTMARKERGENOTYPE_H_
#define TESTMARKERGENOTYPE_H_

#include "models/MarkerConfiguration.h"
#include "models/statuses/MCStatusValid.h"
#include "models/statuses/MCStatusExcDuplication.h"
#include "cute.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class MarkerConfiguration
		 *
		 * Public method of tested class the test methods associated:
		 *
		 * 	- MarkerConfiguration()
		 * 	- MarkerConfiguration()
		 * 	- operator=()
		 * 	- cloneToSmartPtr()
		 * 	- ~MarkerConfiguration();
		 *
		 * 	- addLocus()
		 * 		- testCreateAddLoci
		 *  - cloneMarkerConfigurations()
		 *  	- testCloneMarkerConfigurations()
		 * 	- getLocus()
		 * 		- testCreateAddLoci
		 * 	- getLociNumber()
		 * 		- testCreateAddLoci
		 * 	- isEquivalent()
		 * 		- testEquivalence
		 * 	- isEqual()
		 * 		- testEquivalence
		 * 	- isLocusPresent()
		 * 		- testLocusSearching
		 * 	- getStatus()
		 * 		- testStatusAssignment
		 * 	- getMarkerName()
		 * 		- testCreateAddLoci
		 * 	- getStatus()
		 * 		- testStatusAssignment
		 * 	- getType()
		 * 		- testCreateAddLoci
		 * 	- getTypeAsChar()
		 * 		- testCreateAddLoci
		 * 	- getUniqueAlleles()
		 * 		- testCreateAddLoci
		 * 	- isValid()
		 * 		- testStatusAssignment
		 * 	- setStatus()
		 * 		- testStatusAssignment
		 *  - subtractLocus()
		 *  	- testLocusSubtraction
		 * 	- toString()
		 */
		class TestMarkerConfiguration
		{
		private:
			NumericAllelePtr na1;
			NumericAllelePtr na2;
			NumericAllelePtr na3;
			NumericAllelePtr na4;
			NumericAllelePtr na5;
			NumericAllelePtr na6;
			NumericAllelePtr na7;
			NumericAllelePtr na8;
			NumericAllelePtr na9;

		public:

			TestMarkerConfiguration();
			virtual ~TestMarkerConfiguration();

			void testCopyAndAssigment();
			void testCloneMarkerConfigurations();
			void testEquivalence();
			void testUniqueAlleles();
			void testLocusSearching();
			void testLocusSubtraction();
			void testStatusAssignment();
		};
	}
}

#endif /* TESTMARKERGENOTYPE_H_ */
