/*
 * TestPerson.cpp
 *
 *  Created on: Jul 16, 2009
 *      Author: mariusz
 */

#include "TestPerson.h"

namespace dma
{

	namespace test
	{

		TestPerson::TestPerson()
		{

		}

		TestPerson::~TestPerson()
		{

		}

		void TestPerson::testCreationWithProfile()
		{

			// Creating locus profile
			NumericAllelePtr na0(new NumericAllele(0));
			LocusPtr locus1(new Locus(na0->cloneToPtr(), na0->cloneToPtr()));

			ProfilePtr profile1(new Profile());
			profile1->addMarker( "Marker1", locus1);

			// Testing creation of person without profile
			PersonPtr person1(new Person("Victim1", Person::VICTIM, profile1));
			ASSERT_EQUAL( Person::VICTIM, person1->getType() );
			ASSERT_EQUAL( "Victim1", person1->getPersonId() );
			ASSERT_EQUAL( true, person1->hasProfile() );
			ASSERT_EQUAL( 1, person1->getProfile()->getMarkerNames()->size() );
			ASSERT_EQUAL( "Marker1", person1->getProfile()->getMarkerNames()->at(0) );
		}

		void TestPerson::testCreationWithOutProfile()
		{

			// Testing creation of person without profile
			PersonPtr person1(new Person("Victim1", Person::VICTIM));
			ASSERT_EQUAL( Person::VICTIM, person1->getType() );
			ASSERT_EQUAL( "Victim1", person1->getPersonId() );
			ASSERT_EQUAL( false, person1->hasProfile() );
		}
	}

}
