/*
 * TestSample.h
 *
 *  Created on: Jul 9, 2009
 *      Author: mariusz
 */

#ifndef TESTSAMPLE_H_
#define TESTSAMPLE_H_

#include "cute.h"
#include "models/Sample.h"
#include "models/Marker.h"
#include "models/NumericAllele.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class Sample
		 *
		 * Public method of tested class the test methods associated:
		 *
		 *  - getName()
		 *  	- testEmptySample
		 *  	- testNonEmptySample
		 *  - getPanel()
		 *    	- testEmptySample
		 *  	- testNonEmptySample
		 *  - getMarkersNumber()
		 *    	- testEmptySample
		 *  	- testNonEmptySample
		 *  - addMarker
		 *    	- testCreationAndMarkerAddition
		 *  	- testNonEmptySample
		 *  - getMarker
		 *    	- testCreationAndMarkerAddition
		 *  	- testNonEmptySample
		 *  - getMarkerNames()
		 *    	- testEmptySample
		 *  	- testNonEmptySample
		 *  - toString()
		 *  - operator=
		 *  	- testAssignment
		 */
		class TestSample
		{
		public:
			TestSample();
			virtual ~TestSample();

			void testEmptySample();
			void testNonEmptySample();
			void testAssignment();
		};

	}

}

#endif /* TESTSAMPLE_H_ */


