/*
 * TestSampleConfiguration.h
 *
 *  Created on: Jul 16, 2009
 *      Author: mariusz
 */

#ifndef TESTSAMPLECONFIGURATION_H_
#define TESTSAMPLECONFIGURATION_H_

#include "cute.h"
#include "models/SampleConfiguration.h"
#include "models/NumericAllele.h"
#include "models/statuses/MCStatusExcMixtureProportion.h"

using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class SampleConfiguration
		 *
		 * Public method of tested class the test methods associated:
		 *	- addMarkerConfiguration()
		 *		- testAll
		 *	- addMarkerConfigurations()
		 *		- testAll
		 *	- getMarkerConfigurations()
		 *		- testAll
		 *	- getMarkerNames()
		 *		- testAll
		 *	- getMaximumLociNumber()
		 *		- testAll
		 *	- getName()
		 *		- testAll
		 *	- setName()
		 *		- testAll
		 *	- operator=()
		 *		- testAssignment()
		 */
		class TestSampleConfiguration
		{
		private:

			NumericAllelePtr na_10;
			NumericAllelePtr na_11;
			NumericAllelePtr na_12;
			NumericAllelePtr na_13;
			NumericAllelePtr na_14;
			NumericAllelePtr na_15;
			NumericAllelePtr na_16;
			NumericAllelePtr na_17;
			LocusPtr locus_10_11;
			LocusPtr locus_12_13;
			LocusPtr locus_14_15;
			LocusPtr locus_16_17;
		public:
			TestSampleConfiguration();
			virtual ~TestSampleConfiguration();

			void testAll();
			void testAssignment();
		};

	}

}

#endif /* TESTSAMPLECONFIGURATION_H_ */
