/*
 * TestMCStatus.cpp
 *
 *  Created on: Jan 7, 2009
 *      Author: mariusz
 */

#include "TestMCStatus.h"

namespace dma
{

	namespace test
	{

		TestMCStatus::TestMCStatus()
		{


		}

		TestMCStatus::~TestMCStatus()
		{
			
		}

		void TestMCStatus::testConstructors()
		{

			/// TEST 1
			MarkerConfigurationPtr mcp(new MarkerConfiguration("MARKER_A"));

			ASSERT_EQUAL( true, mcp->isValid() );
			ASSERT_EQUAL( "VALID", mcp->getStatus()->getName() );

			/// TEST 2
			MCStatusExcDuplicationPtr statusExcDup(new MCStatusExcDuplication());
			ASSERT_EQUAL(1, statusExcDup.use_count());
			mcp->setStatus(statusExcDup);
			ASSERT_EQUAL(2, statusExcDup.use_count());
			ASSERT_EQUAL( false, mcp->isValid() );
			ASSERT_EQUAL( "EXCLUDED_DUPLICATION", mcp->getStatus()->getName() );

			/// TEST 3
			MCStatusExcEquivalencePtr statusExcEq(new MCStatusExcEquivalence());
			ASSERT_EQUAL(1, statusExcEq.use_count());
			mcp->setStatus(statusExcEq);
			ASSERT_EQUAL(2, statusExcEq.use_count());
			ASSERT_EQUAL(1, statusExcDup.use_count());
			ASSERT_EQUAL( false, mcp->isValid() );
			ASSERT_EQUAL( "EXCLUDED_EQUIVALENCE", mcp->getStatus()->getName() );

			/// TEST 4
			NumericAllelePtr nap10(new NumericAllele(10.0));
			NumericAllelePtr nap11(new NumericAllele(11.0));
			LocusPtr lcp1(new Locus( nap10->cloneToPtr(), nap11->cloneToPtr() ));

			MCStatusExcHeterozygoticImbalancePtr statusExcHI(new MCStatusExcHeterozygoticImbalance(lcp1, 0.5));
			ASSERT_EQUAL(1, statusExcHI.use_count());
			mcp->setStatus(statusExcHI);
			ASSERT_EQUAL(2, statusExcHI.use_count());
			ASSERT_EQUAL(1, statusExcEq.use_count());

			ASSERT_EQUAL( false, mcp->isValid() );
			ASSERT_EQUAL( "EXCLUDED_HETEROZYGOTIC_IMBALANCE", mcp->getStatus()->getName() );

			/// TEST 5
			MCStatusExcKnownProfilePtr statusExcKP(new MCStatusExcKnownProfile(lcp1));
			ASSERT_EQUAL(1, statusExcKP.use_count());
			mcp->setStatus(statusExcKP);
			ASSERT_EQUAL(2, statusExcKP.use_count());
			ASSERT_EQUAL(1, statusExcHI.use_count());
			ASSERT_EQUAL( false, mcp->isValid() );
			ASSERT_EQUAL( "EXCLUDED_KNOWN_PROFILE", mcp->getStatus()->getName() );

		}
	}
}
