/*
 * TestMCStatusExcAlleleMissing.cpp
 *
 *  Created on: Jul 11, 2009
 *      Author: mariusz
 */

#include "TestMCStatusExcAlleleMissing.h"

namespace dma
{

	namespace test
	{

		TestMCStatusExcAlleleMissing::TestMCStatusExcAlleleMissing()
		{


		}

		TestMCStatusExcAlleleMissing::~TestMCStatusExcAlleleMissing()
		{
			
		}

		void TestMCStatusExcAlleleMissing::testConstructorsAndCloning()
		{
			NumericAllelePtr nap10(new NumericAllele(10));

			// Test creation of status with valid data
			MCStatusExcAlleleMissingPtr status1(new MCStatusExcAlleleMissing(nap10));
			ASSERT_EQUAL( false, status1->isValid() );
			ASSERT_EQUAL( "EXCLUDED_ALLELE_MISSING", status1->getName() );
			ASSERT_EQUAL( 10, status1->getAllele()->getAlleleValue() );

			// Test creation of status with empty data
			MCStatusExcAlleleMissingPtr status2(new MCStatusExcAlleleMissing());
			ASSERT_EQUAL( false, status2->isValid() );
			ASSERT_EQUAL( "EXCLUDED_ALLELE_MISSING", status2->getName() );
			ASSERT_EQUAL( 0, status2->getAllele()->getAlleleValue() );

			// Testing cloning
			MCStatusExcAlleleMissingPtr status3 = boost::dynamic_pointer_cast<MCStatusExcAlleleMissing>( status1->cloneToPtr() );
			ASSERT_EQUAL( false, status3->isValid() );
			ASSERT_EQUAL( "EXCLUDED_ALLELE_MISSING", status3->getName() );
			ASSERT_EQUAL( 10, status3->getAllele()->getAlleleValue() );
		}

	}

}
