/*
 * TestMCStatusExcHeterozygoticImbalance.cpp
 *
 *  Created on: Jul 11, 2009
 *      Author: mariusz
 */

#include "TestMCStatusExcHeterozygoticImbalance.h"

namespace dma
{

	namespace test
	{

		TestMCStatusExcHeterozygoticImbalance::TestMCStatusExcHeterozygoticImbalance()
		{


		}

		TestMCStatusExcHeterozygoticImbalance::~TestMCStatusExcHeterozygoticImbalance()
		{
			
		}

		void TestMCStatusExcHeterozygoticImbalance::testConstructorsAndCloning()
		{

			NumericAllelePtr nap10(new NumericAllele(10.0));
			NumericAllelePtr nap11(new NumericAllele(11.0));
			LocusPtr locus1(new Locus(nap10->cloneToPtr(), nap11->cloneToPtr()));

			// Test creation of status with valid data
			MCStatusExcHeterozygoticImbalancePtr status1(new MCStatusExcHeterozygoticImbalance(locus1, 0.5));
			ASSERT_EQUAL( false, status1->isValid() );
			ASSERT_EQUAL( "EXCLUDED_HETEROZYGOTIC_IMBALANCE", status1->getName() );
			ASSERT_EQUAL( 2, status1->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status1->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status1->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 0.5, status1->getHb() );

			// Test creation of status with empty data
			MCStatusExcHeterozygoticImbalancePtr status2(new MCStatusExcHeterozygoticImbalance());
			ASSERT_EQUAL( false, status2->isValid() );
			ASSERT_EQUAL( "EXCLUDED_HETEROZYGOTIC_IMBALANCE", status2->getName() );
			ASSERT_EQUAL( 2, status2->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 0, status2->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 0, status2->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 0, status2->getHb() );

			// Testing cloning
			MCStatusExcHeterozygoticImbalancePtr status3 = boost::dynamic_pointer_cast<MCStatusExcHeterozygoticImbalance>( status1->cloneToPtr() );
			ASSERT_EQUAL( false, status3->isValid() );
			ASSERT_EQUAL( "EXCLUDED_HETEROZYGOTIC_IMBALANCE", status3->getName() );
			ASSERT_EQUAL( 2, status3->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status3->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status3->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 0.5, status3->getHb() );

		}

	}

}
