/*
 * TestMCStatusExcKnownProfile.cpp
 *
 *  Created on: Jul 11, 2009
 *      Author: mariusz
 */

#include "TestMCStatusExcKnownProfile.h"

namespace dma
{

	namespace test
	{

		TestMCStatusExcKnownProfile::TestMCStatusExcKnownProfile()
		{


		}

		TestMCStatusExcKnownProfile::~TestMCStatusExcKnownProfile()
		{
			
		}

		void TestMCStatusExcKnownProfile::testConstructorsAndCloning()
		{

			NumericAllelePtr nap10(new NumericAllele(10.0));
			NumericAllelePtr nap11(new NumericAllele(11.0));
			LocusPtr locus1(new Locus(nap10->cloneToPtr(), nap11->cloneToPtr()));

			// Test creation of status with valid data
			MCStatusExcKnownProfilePtr status1(new MCStatusExcKnownProfile(locus1));
			ASSERT_EQUAL( false, status1->isValid() );
			ASSERT_EQUAL( "EXCLUDED_KNOWN_PROFILE", status1->getName() );
			ASSERT_EQUAL( 2, status1->getMissingLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status1->getMissingLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status1->getMissingLocus()->getAllele(1)->getAlleleValue() );

			// Test creation of status with empty data
			MCStatusExcKnownProfilePtr status2(new MCStatusExcKnownProfile());
			ASSERT_EQUAL( false, status2->isValid() );
			ASSERT_EQUAL( "EXCLUDED_KNOWN_PROFILE", status2->getName() );
			ASSERT_EQUAL( 2, status2->getMissingLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 0, status2->getMissingLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 0, status2->getMissingLocus()->getAllele(1)->getAlleleValue() );

			// Testing cloning
			MCStatusExcKnownProfilePtr status3 = boost::dynamic_pointer_cast<MCStatusExcKnownProfile>( status1->cloneToPtr() );
			ASSERT_EQUAL( false, status3->isValid() );
			ASSERT_EQUAL( "EXCLUDED_KNOWN_PROFILE", status3->getName() );
			ASSERT_EQUAL( 2, status3->getMissingLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status3->getMissingLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status3->getMissingLocus()->getAllele(1)->getAlleleValue() );

		}

	}

}
