/*
 * TestMCStatusExcMixtureProportion.cpp
 *
 *  Created on: Jul 11, 2009
 *      Author: mariusz
 */

#include "TestMCStatusExcMixtureProportion.h"

namespace dma
{

	namespace test
	{

		TestMCStatusExcMixtureProportion::TestMCStatusExcMixtureProportion()
		{


		}

		TestMCStatusExcMixtureProportion::~TestMCStatusExcMixtureProportion()
		{
			
		}

		void TestMCStatusExcMixtureProportion::testConstructorsAndCloning()
		{

			// Creation of status with valid data
			NumericAllelePtr na10(new NumericAllele(10.0));
			NumericAllelePtr na11(new NumericAllele(11.0));
			LocusPtr locus1(new Locus(na10->cloneToPtr(), na11->cloneToPtr()));
			MCStatusExcMixtureProportionPtr status1(new MCStatusExcMixtureProportion(locus1, 2, 3));

			ASSERT_EQUAL( 2, status1->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status1->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status1->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 2, status1->getExpectedMP() );
			ASSERT_EQUAL( 3, status1->getActualMP() );
			ASSERT_EQUAL( false, status1->isValid() );
			ASSERT_EQUAL( "EXCLUDED_MIXTURE_PROPORTION", status1->getName() );

			// Creation of status with empty data
			MCStatusExcMixtureProportionPtr status2(new MCStatusExcMixtureProportion());
			ASSERT_EQUAL( 2, status2->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 0, status2->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 0, status2->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 0, status2->getExpectedMP() );
			ASSERT_EQUAL( 0, status2->getActualMP() );
			ASSERT_EQUAL( false, status2->isValid() );
			ASSERT_EQUAL( "EXCLUDED_MIXTURE_PROPORTION", status2->getName() );

			// Testing cloning
			MCStatusExcMixtureProportionPtr status3 = boost::dynamic_pointer_cast<MCStatusExcMixtureProportion>( status1->cloneToPtr() );
			ASSERT_EQUAL( 2, status3->getLocus()->getAlleleNumber() );
			ASSERT_EQUAL( 10, status3->getLocus()->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, status3->getLocus()->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 2, status3->getExpectedMP() );
			ASSERT_EQUAL( 3, status3->getActualMP() );
			ASSERT_EQUAL( false, status3->isValid() );
			ASSERT_EQUAL( "EXCLUDED_MIXTURE_PROPORTION", status3->getName() );

		}

	}

}
