/*
 * TestSuiteParsers.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "TestSuiteParsers.h"

namespace dma
{
	namespace test
	{

		TestSuiteParsers::TestSuiteParsers()
		{

			//		suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse));
			//		suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParseBaldingP89));
			//
			//		suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse));
			//		suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParseBaldingP89));


			suite_.push_back(CUTE_SMEMFUN( TestValidator, testIsDouble));
			suite_.push_back(CUTE_SMEMFUN( TestValidator, testIsInteger));

			suite_.push_back(CUTE_SMEMFUN( TestDataParser, testTrimQuotation));
			suite_.push_back(CUTE_SMEMFUN( TestDataParser, testConvertFloatingPoints));

			suite_.push_back(CUTE_SMEMFUN( TestHbDataParser, testParseAndGetHb_valid ));
			suite_.push_back(CUTE_SMEMFUN( TestHbDataParser, testParseAndGetHb_invalid ));

			suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse_valid));
			suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse_invalidColumnNumber));
			suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse_invalidNumericalAllele));
			suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse_invalidTypeConflict));
			suite_.push_back(CUTE_SMEMFUN( TestProfileDataParser, testParse_invalidUndefiedAlleleType));

			suite_.push_back(CUTE_SMEMFUN( TestPopulationDataParser, testParse_valid ));
			suite_.push_back(CUTE_SMEMFUN( TestPopulationDataParser, testParse_invalidAlleleAlleleValue ));
			suite_.push_back(CUTE_SMEMFUN( TestPopulationDataParser, testParse_invalidAlleleFrequency ));
			suite_.push_back(CUTE_SMEMFUN( TestPopulationDataParser, testParse_invalidUnknownMarker ));

			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_valid ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidAlleleSize ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidAlleleValue ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidPeakHeight ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidPeakArea ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidTypeConflict ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserColumnarFormat, testParse_invalidColumnsNumber ));

			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_valid ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidAlleleSize ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidAlleleValue ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidPeakHeight ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidPeakArea ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidTypeConflict ));
			suite_.push_back(CUTE_SMEMFUN( TestMixtureDataParserLinearFormat, testParse_invalidColumnsNumber ));

			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_valid ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidSampleNameNotGiven ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidMarkerNameNotGiven ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidMarkerTypeIncorrect1 ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidMarkerTypeIncorrect2 ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidContributorNumberNotGiven ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidContributorNumberNotNumerical ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidContributorNumberZero ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidStatusNotGiven ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidStatusIncorrect ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidAlleleTypeConflict ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidIncorrectColumnsNumber ));
			suite_.push_back(CUTE_SMEMFUN( TestOutputDataParser, testParse_invalidLocusData ));

			suite_.push_back(CUTE_SMEMFUN( TestExternalDataParser, testParseMixtureDataFile_invalidNoData ));
			suite_.push_back(CUTE_SMEMFUN( TestExternalDataParser, testParseMixtureDataFile_invalidSampleNumber ));
			suite_.push_back(CUTE_SMEMFUN( TestExternalDataParser, testParsePopulationDataFile_invalidNoData ));
			suite_.push_back(CUTE_SMEMFUN( TestExternalDataParser, testParseHbDataFile_invalidNoData ));
			suite_.push_back(CUTE_SMEMFUN( TestExternalDataParser, testParseOutputDataFile_invalidNoData ));

		}

		TestSuiteParsers::~TestSuiteParsers()
		{

		}

		void TestSuiteParsers::runTests()
		{
			cute::ide_listener lis;
			cute::makeRunner(lis)(suite_, "Test suite - Parsers ");
		}

	}
}
