/*
 * TestDataParser.cpp
 *
 *  Created on: Jul 24, 2009
 *      Author: mariusz
 */

#include "TestDataParser.h"

namespace dma
{

	namespace test
	{

		TestDataParser::TestDataParser() : DataParser("data/parsers/test_data_parser/test_data_parser_empty_file.txt", "Data Parser tests", "")

		{

		}

		TestDataParser::~TestDataParser()
		{

		}

		void TestDataParser::testTrimQuotation()
		{

			// Generating quoted string
			std::string stringWithOutQuotations = "Alice does \"not\" have a cat ";
			std::string stringWithQuotations = "\"" + stringWithOutQuotations + "\"";

			// Testing
			std::string result = this->trimQuotation(stringWithQuotations);
			ASSERT_EQUAL( stringWithOutQuotations, result );
		}
		void TestDataParser::testConvertFloatingPoints()
		{

			// Generating numbers
			std::string numberRef = "100.0";
			std::string numberComma = "100,0";
			std::string numberDot = "100.0";

			std::string resultComma = this->convertFloatingPoints(numberComma);
			std::string resultDot = this->convertFloatingPoints(numberDot);

			ASSERT_EQUAL( numberRef, resultComma );
			ASSERT_EQUAL( numberRef, resultDot );

		}
	}

}
