/*
 * TestExternalDataParser.cpp
 *
 *  Created on: Jul 28, 2009
 *      Author: mariusz
 */

#include "TestExternalDataParser.h"

namespace dma
{

	namespace test
	{

		TestExternalDataParser::TestExternalDataParser() :
					fileEmpty("data/parsers/test_external_data_parser/test_external_data_parser_empty_file.txt"),
					fileInvaldSequenceNumber("data/parsers/test_external_data_parser/test_external_data_parser_invalid_sample_number.txt")
		{

		}

		TestExternalDataParser::~TestExternalDataParser()
		{

		}

		void TestExternalDataParser::testParseMixtureDataFile_invalidNoData()
		{

			// Creating parser
			ExternalDataParserPtr parser1(new ExternalDataParser());

			try
			{

				parser1->parseMixtureDataFile(fileEmpty, ExternalDataParser::COLUMNAR_FORMAT);
				ASSERTM( "Expected exception. Nothing throwned", 0 == 1 );
			} catch (ParserException e)
			{

				ASSERT_EQUAL( MixtureDataParserColumnarFormat::getFileType(), e.getFileType() );
				ASSERT_EQUAL( fileEmpty, e.getFilename() );
			}
		}

		void TestExternalDataParser::testParseMixtureDataFile_invalidSampleNumber()
		{

			// Creating parser
			ExternalDataParserPtr parser1(new ExternalDataParser());

			try
			{

				parser1->parseMixtureDataFile(fileInvaldSequenceNumber, ExternalDataParser::COLUMNAR_FORMAT);
				ASSERTM( "Expected exception. Nothing throwned", 0 == 1 );
			} catch (ParserException e)
			{

				ASSERT_EQUAL( MixtureDataParserColumnarFormat::getFileType(), e.getFileType() );
				ASSERT_EQUAL( fileInvaldSequenceNumber, e.getFilename() );
			}
		}

		void TestExternalDataParser::testParsePopulationDataFile_invalidNoData()
		{

			// Creating parser
			ExternalDataParserPtr parser1(new ExternalDataParser());

			try
			{

				parser1->parsePopulationDataFile(fileEmpty);
				ASSERTM( "Expected exception. Nothing throwned", 0 == 1 );
			} catch (ParserException e)
			{

				ASSERT_EQUAL( PopulationDataParser::getFileType(), e.getFileType() );
				ASSERT_EQUAL( fileEmpty, e.getFilename() );
			}
		}

		void TestExternalDataParser::testParseHbDataFile_invalidNoData()
		{

			// Creating parser
			ExternalDataParserPtr parser1(new ExternalDataParser());

			try
			{

				parser1->parseHbDataFile(fileEmpty);
				ASSERTM( "Expected exception. Nothing throwned", 0 == 1 );
			} catch (ParserException e)
			{

				ASSERT_EQUAL( HbDataParser::getFileType(), e.getFileType() );
				ASSERT_EQUAL( fileEmpty, e.getFilename() );
			}
		}

		void TestExternalDataParser::testParseOutputDataFile_invalidNoData()
		{

			// Creating parser
			ExternalDataParserPtr parser1(new ExternalDataParser());

			try
			{

				parser1->parseOutputDataFile(fileEmpty);
				ASSERTM( "Expected exception. Nothing throwned", 0 == 1 );
			} catch (ParserException e)
			{

				ASSERT_EQUAL( OutputDataParser::getFileType(), e.getFileType() );
				ASSERT_EQUAL( fileEmpty, e.getFilename() );
			}
		}

	}

}
