/*
 * TestHbDataParser.h
 *
 *  Created on: Nov 9, 2008
 *      Author: mariusz
 */

#ifndef TESTHBDATAPARSER_H_
#define TESTHBDATAPARSER_H_

#include <string>
#include <map>
#include "cute.h"
#include "TypeDefinitions.h"
#include "parsers/HbDataParser.h"
#include <boost/shared_ptr.hpp>

using namespace dma::external;
using namespace dma::core;

namespace dma
{

	namespace test
	{

		/**
		 * Unit test class for @class HbDataParser
		 *
		 * Method of tested class the test methods associated:
		 *
		 * 	- parse()
		 * 		- testParseAndGetHb()
		 * 	- getHb()
		 * 		- testParseAndGetHb()
		 */
		class TestHbDataParser
		{
		private:

			std::string validFile_;
			std::string invalidFile_;

		public:
			TestHbDataParser();
			virtual ~TestHbDataParser();

			void testParseAndGetHb_valid();
			void testParseAndGetHb_invalid();
		};
	}
}


#endif /* TESTHBDATAPARSER_H_ */
