/*
 * TestProfileDataParser.h
 *
 *  Created on: Dec 6, 2008
 *      Author: mariusz
 */

#ifndef TESTPROFILEDATAPARSER_H_
#define TESTPROFILEDATAPARSER_H_

#include "cute.h"
#include <string>
#include <iostream>
#include "parsers/ProfileDataParser.h"
#include <boost/shared_ptr.hpp>

using namespace dma::external;

namespace dma
{

	namespace test
	{

		class TestProfileDataParser
		{
		private:

			std::string fileValid_;
			std::string fileInvalidColumnNumber_;
			std::string fileInvalidNumericalAllele_;
			std::string fileInvalidTypeConflict_;
			std::string fileInvalidUndefiedAlleleType_;

		public:
			TestProfileDataParser();
			virtual ~TestProfileDataParser();

			void testParse_valid();
			void testParse_invalidColumnNumber();
			void testParse_invalidNumericalAllele();
			void testParse_invalidTypeConflict();
			void testParse_invalidUndefiedAlleleType();
		};

	}
}

#endif /* TESTPROFILEDATAPARSER_H_ */

