/*
 * TestHypothesisPython.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "TestHypothesisPython.h"

namespace dma
{
	namespace test
	{

		TestHypothesisPython::TestHypothesisPython()
		{

		}

		TestHypothesisPython::~TestHypothesisPython()
		{

		}

		void TestHypothesisPython::testConstuctionValidType()
		{

			HypothesisPython* hp = new HypothesisPython("HP", "P");
			HypothesisPython* hd = new HypothesisPython("HD", "D");

			// Testing hypothesis without any persons given
			ASSERT_EQUAL( Hypothesis::PROSECUTOR, hp->getHypothesis()->getType() );
			ASSERT_EQUAL( Hypothesis::DEFENCE, hd->getHypothesis()->getType() );
			ASSERT_EQUAL( 0, hp->getHypothesis()->getNumberOfContributors() );
			ASSERT_EQUAL( 0, hd->getHypothesis()->getNumberOfContributors() );

			// Creating persons and adding them to hypothesis
			PersonPython personHp1("PERSON_HP_1", "[['MarkerA', '10', '11']]");
			PersonPython personHp2("PERSON_HP_2", "");
			PersonPython personHd1("PERSON_HD_1", "");
			PersonPython personHd2("PERSON_HD_2", "");
			hp->addContributor(personHp1);
			hp->addContributor(personHp2);
			hd->addContributor(personHd1);
			hd->addContributor(personHd2);

			// Testing hypothesis with persons given
			ASSERT_EQUAL( 2, hp->getHypothesis()->getNumberOfContributors() );
			ASSERT_EQUAL( 2, hd->getHypothesis()->getNumberOfContributors() );
			ASSERT_EQUAL( "PERSON_HP_1", hp->getHypothesis()->getContributor(0)->getPersonId() );
			ASSERT_EQUAL( true, hp->getHypothesis()->getContributor(0)->hasProfile() );
			ASSERT_EQUAL( 1, hp->getHypothesis()->getContributor(0)->getProfile()->getMarkerNames()->size() );
			ASSERT_EQUAL( 2, hp->getHypothesis()->getContributor(0)->getProfile()->getMarker("MarkerA")->getAlleleNumber() );
			ASSERT_EQUAL( 10, hp->getHypothesis()->getContributor(0)->getProfile()->getMarker("MarkerA")->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 11, hp->getHypothesis()->getContributor(0)->getProfile()->getMarker("MarkerA")->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( "PERSON_HP_2", hp->getHypothesis()->getContributor(1)->getPersonId() );
			ASSERT_EQUAL( false, hp->getHypothesis()->getContributor(1)->hasProfile() );
			ASSERT_EQUAL( "PERSON_HD_1", hd->getHypothesis()->getContributor(0)->getPersonId() );
			ASSERT_EQUAL( false, hd->getHypothesis()->getContributor(0)->hasProfile() );
			ASSERT_EQUAL( "PERSON_HD_2", hd->getHypothesis()->getContributor(1)->getPersonId() );
			ASSERT_EQUAL( false, hd->getHypothesis()->getContributor(1)->hasProfile() );
		}

		void TestHypothesisPython::testConstuctionInvalidType()
		{

			ASSERT_THROWS( new HypothesisPython("HP", "U"), std::runtime_error );
		}

	}
}
