/*
 * TestPersonPython.cpp
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#include "TestPersonPython.h"

namespace dma
{

	namespace test
	{

		TestPersonPython::TestPersonPython()
		{

		}

		TestPersonPython::~TestPersonPython()
		{

		}

		void TestPersonPython::testConstructionNoProfile()
		{

			PersonPython* pp = new PersonPython("PERSON_TEST_1", "");
			PersonPtr person = pp->getPerson();

			// Performing tests on Person
			ASSERT_EQUAL( "PERSON_TEST_1", person->getPersonId() );
			ASSERT_EQUAL( false, person->hasProfile() );
		}

		void TestPersonPython::testConstructionProfileValid()
		{

			PersonPython* pp = new PersonPython("PERSON_TEST_2", "[	['AMEL', 'X', 'Y'], ['D16S539', '12', '13']]");
			PersonPtr person = pp->getPerson();

			// Performing tests on Person
			ASSERT_EQUAL( "PERSON_TEST_2", person->getPersonId() );
			ASSERT_EQUAL( true, person->hasProfile() );

			// Performing test on persons profile
			ProfilePtr profile = person->getProfile();
			ASSERT_EQUAL( 2, profile->getMarkerNames()->size() );
			ASSERT_EQUAL( 2, profile->getMarker("AMEL")->getAlleleNumber() );
			ASSERT_EQUAL( (double)('X'), profile->getMarker("AMEL")->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( (double)('Y'), profile->getMarker("AMEL")->getAllele(1)->getAlleleValue() );
			ASSERT_EQUAL( 2, profile->getMarker("D16S539")->getAlleleNumber() );
			ASSERT_EQUAL( 12.0, profile->getMarker("D16S539")->getAllele(0)->getAlleleValue() );
			ASSERT_EQUAL( 13.0, profile->getMarker("D16S539")->getAllele(1)->getAlleleValue() );

			delete pp;
		}

		void TestPersonPython::testConstructionProfileInvalid1()
		{

			std::string personId = "PERSON_TEST_3";
			std::string personData = "12";

			ASSERT_THROWS( new PersonPython(personId, personData), std::runtime_error );
		}

		void TestPersonPython::testConstructionProfileInvalid2()
		{
			std::string personId = "PERSON_TEST_4";
			std::string personData = "[	10, 11 ]";

			ASSERT_THROWS( new PersonPython(personId, personData), std::runtime_error );
		}

		void TestPersonPython::testConstructionProfileInvalid3()
		{
			std::string personId = "PERSON_TEST_5";
			std::string personData = "[	['AMEL', 'X'], ['D16S539', '12']]";

			ASSERT_THROWS( new PersonPython(personId, personData), std::runtime_error );
		}

	}
}
