/*
 * TestPersonPython.h
 *
 *  Created on: Jan 25, 2009
 *      Author: mariusz
 */

#ifndef TESTPERSONPYTHON_H_
#define TESTPERSONPYTHON_H_

#include <string>

#include "python/models/PersonPython.h"
#include "cute.h"

using namespace dma::python;

namespace dma
{
	namespace test
	{

		class TestPersonPython
		{
		public:
			TestPersonPython();
			virtual ~TestPersonPython();

			/**
			 * Test construction of person which does not have profile attached
			 */
			void testConstructionNoProfile();

			/**
			 * Test construction of person which has valid profile attached
			 */
			void testConstructionProfileValid();

			/**
			 * Test construction of person which has profile in incorrect format attached:
			 *
			 * Object instead of array given in level 1.
			 * Profile given in JSON format: '12'
			 */
			void testConstructionProfileInvalid1();

			/**
			 * Test construction of person which has profile in incorrect format attached:
			 *
			 * Objects instead of array given in level 2
			 * Profile given in JSON format: '[ 10, 11 ]'
			 */
			void testConstructionProfileInvalid2();

			/**
			 * Test construction of person which has profile in incorrect format attached:
			 *
			 * Incorrect number of elements in array in level 2 ( expecting 3: 2 given ).
			 * Profile given in JSON format: '[ ['AMEL', 'X'], ['D16S539', '12']]'
			 *
			 */
			void testConstructionProfileInvalid3();
		};

	}
}

#endif /* TESTPERSONPYTHON_H_ */
