from django.db import models
from django.conf import settings

import simplejson as json

class LikelihoodRatio:
    
    # Formula representing likelihood ratio
    formula = '';
    
    # Likelihood ratio value
    value = 0;

class TableCell:
    
    # Cell type - 'D'|'H'
    type = 'D';
    
    # Cell contents
    contents = '';
    
    # Cell colspan
    colspan = 1;

#
# Class representing result of mixture deconvolution
#
class MixtureDeconvolutionResult:
    
    # Flag indicating whether any error has been reported during file processing or calculations  
    flagIsError = False;
    
    # Container for error message
    errorMessage = '';
    
    # Table with result of mixture deconvolution
    resultsTable = None;
    
    # Table with result of mixture deconvolution which can be displayed by template system
    resultsTableHtml = None;
    
    # Upload result
    uploadResult = None;
    
    # Filename of generated report
    reportFilename = '';
    
class LrCalculationResult:
    
    # Flag indicating whether any error has been reported during file processing or calculations  
    flagIsError = False;
    
    # Container for error message
    errorMessage = '';   
    
    # Dictionary containing objects of type LikelihoodRatio
    lrs = {};
        
    # Total LR value for whole sample
    totalLrValue = 0.0;
    
#
# Class representing result of process of handling uploaded mixture and heterozygotic balance data file
#
class MDDataFileUploadResult:
    
    # Flag indicating whether files saving has been successfully performed 
    saveResult = False;
    
    # Path to saved heterozygotic balance data file 
    pathToSavedHbdf = '';
    
    # Path to save mixture sample data file
    pathToSavedMdf = '';
    
#
# Class representing result of process of handling uploaded LR calculations data files
#
class LrDataFileUploadResult:
    
    # Flag indicating whether files saving has been successfully performed 
    saveResult = False;
    
    # Path to saved heterozygotic balance data file 
    pathToSavedOdf = '';
    
    # Path to save mixture sample data file
    pathToSavedPdf = '';
    
#
# Class representing result of process of handling uploaded known profiles data file
#
class KpDataFileUploadResult:
    
    # Response code in case of valid request
    RESPONSE_CODE_VALID = 200;
    
    # Response code in case of invalid request
    RESPONSE_CODE_ERROR = 500;
    
    # Response code - 200 | 500
    responseCode = RESPONSE_CODE_VALID;
    
    # Response body
    responseBody = '';
    
    # Contributor number
    contributorNumber = -1;
    
    # Hypothesis type
    hypothesis = '';

# Class representing contributor to the mixture
class Contributor:
    
    # Contributor number
    number = -1;
    
    # Contributor name
    name = '';
    
    # Profile given as 2-dimensional array
    profile = [];
    
    #
    # Constructor
    # @param lNumber: Contributor number
    # @param lName: Contributor name 
    def __init__(self, lNumber, lName):
        self.name = lName;
        self.number = lNumber;
    
    #
    # Method returns information whether contributor has profile assosiated with him 
    # @return: Boolean value
    def hasProfile(self):
        if len(self.profile) > 0:
            return True;
        else:
            return False;
        
    def __str__(self):
        
        buffer = '';
        buffer += 'Contributor ( ' + self.name + ', ' + str(self.number) + ')\n';
        if self.hasProfile() == True:
            buffer += str( self.profile );
        else:
            buffer += 'No profile is given';
         
        return buffer;
    
    def __repr__(self):
        return self.__str__();
    
    def getProfileAsJson(self):
        
        if len(self.profile) > 0:
            return json.dumps( self.profile );
        else:
            return "";
    
        
        

        

    